package com.cursedcauldron.wildbackport.client.animation.api;

import java.util.Optional;
import java.util.function.Function;

import com.cursedcauldron.wildbackport.core.mixin.access.ModelPartAccessor;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1160;
import net.minecraft.class_1297;
import net.minecraft.class_1921;
import net.minecraft.class_2960;
import net.minecraft.class_5597;
import net.minecraft.class_630;

//<>

@Environment(EnvType.CLIENT)
public abstract class AnimatedModel<E extends class_1297> extends class_5597<E> {
    private static final class_1160 CACHE = new class_1160();

    public AnimatedModel() {
        this(class_1921::method_23578);
    }

    public AnimatedModel(Function<class_2960, class_1921> function) {
        super(function);
    }

    public Optional<class_630> getChild(String name) {
        return this.method_32008()
            .method_32088()
            .filter(
                part
                -> ((ModelPartAccessor) (Object) part).getChildren().containsKey(name)
            )
            .findFirst()
            .map(part -> part.method_32086(name));
    }

    protected void
    animate(AnimationState state, Animation animation, float animationProgress) {
        this.animate(state, animation, animationProgress, 1.0F);
    }

    protected void animate(
        AnimationState animationState,
        Animation animation,
        float animationProgress,
        float speedMultiplier
    ) {
        animationState.run(animationProgress, speedMultiplier);
        animationState.run(
            state
            -> AnimationHelper.animate(this, animation, state.runningTime(), 1.0F, CACHE)
        );
    }
}