package com.cursedcauldron.wildbackport.client.particle;

import java.util.function.Consumer;
import net.minecraft.class_1158;
import net.minecraft.class_1160;
import net.minecraft.class_156;
import net.minecraft.class_243;
import net.minecraft.class_3532;
import net.minecraft.class_3999;
import net.minecraft.class_4002;
import net.minecraft.class_4003;
import net.minecraft.class_4184;
import net.minecraft.class_4588;
import net.minecraft.class_638;
import net.minecraft.class_703;
import record;

public class ShriekParticle extends class_4003 {
    private static final class_1160 AXIS
        = class_156.method_654(new class_1160(0.5F, 0.5F, 0.5F), class_1160::method_4952);
    private static final class_1160 OFFSET = new class_1160(-1.0F, -1.0F, 0.0F);
    private int delay;

    protected ShriekParticle(class_638 level, double x, double y, double z, int delay) {
        super(level, x, y, z);
        this.field_17867 = 0.85F;
        this.delay = delay;
        this.field_3847 = 30;
        this.field_3844 = 0.0F;
        this.field_3852 = 0.0D;
        this.field_3869 = 0.1D;
        this.field_3850 = 0.0D;
    }

    @Override
    public float method_18132(float tickDelta) {
        return this.field_17867
            * class_3532.method_15363(
                ((float) this.field_3866 + tickDelta) / (float) this.field_3847 * 0.75F, 0.0F, 1.0F
            );
    }

    @Override
    public void method_3074(class_4588 vertex, class_4184 camera, float tickDelta) {
        if (this.delay > 0)
            return;
        this.field_3841 = 1.0F
            - class_3532.method_15363(
                ((float) this.field_3866 + tickDelta) / (float) this.field_3847 * 0.75F, 0.0F, 1.0F
            );
        this.render(vertex, camera, tickDelta, quaternion -> {
            quaternion.method_4925(class_1160.field_20705.method_23626(0.0F));
            quaternion.method_4925(class_1160.field_20703.method_23626(-1.0472F));
        });
        this.render(vertex, camera, tickDelta, quaternion -> {
            quaternion.method_4925(class_1160.field_20705.method_23626((float) (-Math.PI)));
            quaternion.method_4925(class_1160.field_20703.method_23626(1.0472F));
        });
    }

    private void render(
        class_4588 vertex,
        class_4184 camera,
        float tickDelta,
        Consumer<class_1158> consumer
    ) {
        class_243 pos = camera.method_19326();
        float x = (float) (class_3532.method_16436(tickDelta, this.field_3858, this.field_3874) - pos.method_10216());
        float y = (float) (class_3532.method_16436(tickDelta, this.field_3838, this.field_3854) - pos.method_10214());
        float z = (float) (class_3532.method_16436(tickDelta, this.field_3856, this.field_3871) - pos.method_10215());
        class_1158 quaternion = new class_1158(AXIS, 0.0F, true);
        consumer.accept(quaternion);
        OFFSET.method_19262(quaternion);
        class_1160[] vectors = new class_1160[] { new class_1160(-1.0F, -1.0F, 0.0F),
                                              new class_1160(-1.0F, 1.0F, 0.0F),
                                              new class_1160(1.0F, 1.0F, 0.0F),
                                              new class_1160(1.0F, -1.0F, 0.0F) };
        float quadSize = this.method_18132(tickDelta);

        for (int i = 0; i < 4; i++) {
            class_1160 vector = vectors[i];
            vector.method_19262(quaternion);
            vector.method_4942(quadSize);
            vector.method_4948(x, y, z);
        }

        int light = this.method_3068(tickDelta);
        this.addVertex(vertex, vectors[0], this.method_18134(), this.method_18136(), light);
        this.addVertex(vertex, vectors[1], this.method_18134(), this.method_18135(), light);
        this.addVertex(vertex, vectors[2], this.method_18133(), this.method_18135(), light);
        this.addVertex(vertex, vectors[3], this.method_18133(), this.method_18136(), light);
    }

    private void
    addVertex(class_4588 vertex, class_1160 vector, float u, float v, int light) {
        vertex.method_22912(vector.method_4943(), vector.method_4945(), vector.method_4947())
            .method_22913(u, v)
            .method_22915(this.field_3861, this.field_3842, this.field_3859, this.field_3841)
            .method_22916(light)
            .method_1344();
    }

    @Override
    protected int method_3068(float tint) {
        return 240;
    }

    @Override
    public class_3999 method_18122() {
        return class_3999.field_17829;
    }

    @Override
    public void method_3070() {
        if (this.delay > 0) {
            --this.delay;
            return;
        }
        super.method_3070();
    }

    public record Provider(class_4002 spriteSet)
        implements ParticleProvider<ShriekParticleOptions> {
        @Override
        public class_703 createParticle(
            ShriekParticleOptions options,
            class_638 level,
            double x,
            double y,
            double z,
            double xMotion,
            double yMotion,
            double zMotion
        ) {
            ShriekParticle particle = new ShriekParticle(level, x, y, z, options.delay());
            particle.method_18140(this.spriteSet);
            particle.method_3083(1.0F);
            return particle;
        }
    }
}