package com.cursedcauldron.wildbackport.client.registry;

import java.util.function.Function;
import java.util.function.Supplier;
import net.minecraft.class_2378;
import net.minecraft.class_2394;
import net.minecraft.class_2396;
import net.minecraft.class_2400;
import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.client.particle.SculkChargeParticleOptions;
import com.cursedcauldron.wildbackport.client.particle.ShriekParticleOptions;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;
import com.cursedcauldron.wildbackport.core.mixin.access.SimpleParticleTypeAccessor;
import com.mojang.serialization.Codec;

//<>

public class WBParticleTypes {
    public static final CoreRegistry<class_2396<?>> PARTICLES
        = CoreRegistry.create(class_2378.field_11141, "minecraft");

    public static final Supplier<class_2400> SCULK_SOUL
        = create("sculk_soul", false);
    public static final Supplier<class_2396<SculkChargeParticleOptions>> SCULK_CHARGE
        = create(
            "sculk_charge",
            SculkChargeParticleOptions.DESERIALIZER,
            type
            -> SculkChargeParticleOptions.CODEC,
            true
        );
    public static final Supplier<class_2400> SCULK_CHARGE_POP
        = create("sculk_charge_pop", true);
    public static final Supplier<class_2396<ShriekParticleOptions>> SHRIEK = create(
        "shriek",
        ShriekParticleOptions.DESERIALIZER,
        type
        -> ShriekParticleOptions.CODEC,
        true
    );
    public static final Supplier<class_2400> SONIC_BOOM
        = create("sonic_boom", true);

    private static Supplier<class_2400> create(String key, boolean alwaysShow) {
        return PARTICLES.register(
            key, () -> SimpleParticleTypeAccessor.createSimpleParticleType(alwaysShow)
        );
    }

    private static <T extends class_2394> Supplier<class_2396<T>> create(
        String key,
        class_2394.class_2395<T> deserializer,
        Function<class_2396<T>, Codec<T>> function,
        boolean alwaysShow
    ) {
        return PARTICLES.register(
            key,
            () -> new class_2396<>(alwaysShow, deserializer) {
                @Override
                public Codec<T> method_29138() {
                    return function.apply(this);
                }
            }
        );
    }
}