package com.cursedcauldron.wildbackport.client.render;

import java.util.Map;
import net.minecraft.class_156;
import net.minecraft.class_2960;
import net.minecraft.class_5601;
import net.minecraft.class_5617;
import net.minecraft.class_927;
import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.client.render.model.FrogModel;
import com.cursedcauldron.wildbackport.common.entities.Frog;
import com.google.common.collect.Maps;

public class FrogRenderer extends class_927<Frog, FrogModel<Frog>> {
    public static final class_5601 MODEL_LAYER
        = new class_5601(new class_2960("frog"), "main");

    private static final Map<Frog.Variant, class_2960> TEXTURES
        = class_156.method_654(Maps.newHashMap(), hashMap -> {
              for (Frog.Variant variant : Frog.Variant.values()) {
                  hashMap.put(
                      variant,
                      new class_2960(String.format(
                          "textures/entity/frog/%s_frog.png", variant.getName()
                      ))
                  );
              }
          });

    public FrogRenderer(class_5617.class_5618 context) {
        super(context, new FrogModel<>(context.method_32167(MODEL_LAYER)), 0.3f);
    }

    @Override
    public class_2960 getTextureLocation(Frog frog) {
        return TEXTURES.get(frog.getVariant());
    }
}