package com.cursedcauldron.wildbackport.client.render;

import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.client.render.model.WardenModel;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2960;
import net.minecraft.class_3532;
import net.minecraft.class_5601;
import net.minecraft.class_5617;
import net.minecraft.class_927;

//<>

@Environment(EnvType.CLIENT)
public class WardenRenderer extends class_927<Warden, WardenModel<Warden>> {
    public static final class_5601 MODEL_LAYER
        = new class_5601(new class_2960("warden"), "main");

    private static final class_2960 TEXTURE
        = new class_2960("textures/entity/warden/warden.png");
    private static final class_2960 BIOLUMINESCENT_LAYER_TEXTURE
        = new class_2960("textures/entity/warden/warden_bioluminescent_layer.png");
    private static final class_2960 HEART_TEXTURE
        = new class_2960("textures/entity/warden/warden_heart.png");
    private static final class_2960 PULSATING_SPOTS_1_TEXTURE
        = new class_2960("textures/entity/warden/warden_pulsating_spots_1.png");
    private static final class_2960 PULSATING_SPOTS_2_TEXTURE
        = new class_2960("textures/entity/warden/warden_pulsating_spots_2.png");

    public WardenRenderer(class_5617.class_5618 ctx) {
        super(ctx, new WardenModel<>(ctx.method_32167(MODEL_LAYER)), 0.9F);
        this.method_4046(new WardenLayerRenderer<>(
            this,
            BIOLUMINESCENT_LAYER_TEXTURE,
            (entity, tickDelta, animationProgress)
                -> 1.0F,
            WardenModel::getHeadAndLimbs
        ));
        this.method_4046(new WardenLayerRenderer<>(
            this,
            PULSATING_SPOTS_1_TEXTURE,
            (entity, tickDelta, animationProgress)
                -> Math.max(0.0F, class_3532.method_15362(animationProgress * 0.045F) * 0.25F),
            WardenModel::getBodyHeadAndLimbs
        ));
        this.method_4046(new WardenLayerRenderer<>(
            this,
            PULSATING_SPOTS_2_TEXTURE,
            (entity, tickDelta, animationProgress)
                -> Math.max(
                    0.0F, class_3532.method_15362(animationProgress * 0.045F + (float) Math.PI) * 0.25F
                ),
            WardenModel::getBodyHeadAndLimbs
        ));
        this.method_4046(new WardenLayerRenderer<>(
            this,
            TEXTURE,
            (entity, tickDelta, animationProgress)
                -> entity.getTendrilPitch(tickDelta),
            WardenModel::getTendrils
        ));
        this.method_4046(new WardenLayerRenderer<>(
            this,
            HEART_TEXTURE,
            (entity, tickDelta, animationProgress)
                -> entity.getHeartPitch(tickDelta),
            WardenModel::getBody
        ));
    }

    @Override
    public class_2960 getTextureLocation(Warden warden) {
        return TEXTURE;
    }
}