package com.cursedcauldron.wildbackport.client.render.model;

import com.cursedcauldron.wildbackport.client.animation.api.Animated;
import com.cursedcauldron.wildbackport.common.entities.Allay;
import net.minecraft.class_1160;
import net.minecraft.class_1306;
import net.minecraft.class_3532;
import net.minecraft.class_3881;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_5597;
import net.minecraft.class_5603;
import net.minecraft.class_5605;
import net.minecraft.class_5606;
import net.minecraft.class_5607;
import net.minecraft.class_5609;
import net.minecraft.class_5610;
import net.minecraft.class_630;

//<>

public class AllayModel extends class_5597<Allay> implements class_3881 {
    private final class_630 root;
    private final class_630 head;
    private final class_630 body;
    private final class_630 right_arm;
    private final class_630 left_arm;
    private final class_630 right_wing;
    private final class_630 left_wing;

    public AllayModel(class_630 part) {
        this.root = part.method_32086("root");
        this.head = this.root.method_32086("head");
        this.body = this.root.method_32086("body");
        this.right_arm = this.body.method_32086("right_arm");
        this.left_arm = this.body.method_32086("left_arm");
        this.right_wing = this.body.method_32086("right_wing");
        this.left_wing = this.body.method_32086("left_wing");
    }

    public static class_5607 createBodyLayer() {
        class_5609 mesh = new class_5609();
        class_5610 root = mesh.method_32111().method_32117(
            "root", class_5606.method_32108(), class_5603.method_32090(0.0F, 23.5F, 0.0F)
        );
        root.method_32117(
            "head",
            class_5606.method_32108().method_32101(0, 0).method_32098(
                -2.5F, -5.0F, -2.5F, 5.0F, 5.0F, 5.0F, new class_5605(0.0F)
            ),
            class_5603.method_32090(0.0F, -3.99F, 0.0F)
        );
        class_5610 body = root.method_32117(
            "body",
            class_5606.method_32108()
                .method_32101(0, 10)
                .method_32098(-1.5F, 0.0F, -1.0F, 3.0F, 4.0F, 2.0F, new class_5605(0.0F))
                .method_32101(0, 16)
                .method_32098(-1.5F, 0.0F, -1.0F, 3.0F, 5.0F, 2.0F, new class_5605(-0.2F)),
            class_5603.method_32090(0.0F, -4.0F, 0.0F)
        );
        body.method_32117(
            "right_arm",
            class_5606.method_32108().method_32101(23, 0).method_32098(
                -0.75F, -0.5F, -1.0F, 1.0F, 4.0F, 2.0F, new class_5605(-0.01F)
            ),
            class_5603.method_32090(-1.75F, 0.5F, 0.0F)
        );
        body.method_32117(
            "left_arm",
            class_5606.method_32108().method_32101(23, 6).method_32098(
                -0.25F, -0.5F, -1.0F, 1.0F, 4.0F, 2.0F, new class_5605(-0.01F)
            ),
            class_5603.method_32090(1.75F, 0.5F, 0.0F)
        );
        body.method_32117(
            "right_wing",
            class_5606.method_32108().method_32101(16, 14).method_32098(
                0.0F, 1.0F, 0.0F, 0.0F, 5.0F, 8.0F, new class_5605(0.0F)
            ),
            class_5603.method_32090(-0.5F, 0.0F, 0.65F)
        );
        body.method_32117(
            "left_wing",
            class_5606.method_32108().method_32101(16, 14).method_32098(
                0.0F, 1.0F, 0.0F, 0.0F, 5.0F, 8.0F, new class_5605(0.0F)
            ),
            class_5603.method_32090(0.5F, 0.0F, 0.65F)
        );
        return class_5607.method_32110(mesh, 32, 32);
    }

    @Override
    public void setupAnim(
        Allay entity,
        float angle,
        float distance,
        float animationProgress,
        float yaw,
        float pitch
    ) {
        this.method_32008().method_32088().forEach(Animated::resetToDefault);
        this.head.field_3654 = pitch * ((float) Math.PI / 180F);
        this.head.field_3675 = yaw * ((float) Math.PI / 180F);
        float f = animationProgress * 20.0F * ((float) Math.PI / 180F) + distance;
        float f1 = class_3532.method_15362(f) * (float) Math.PI * 0.15F;
        float f2 = animationProgress - (float) entity.field_6012;
        float f3 = animationProgress * 9.0F * ((float) Math.PI / 180F);
        float f4 = Math.min(distance / 0.3F, 1.0F);
        float f5 = 1.0F - f4;
        float holdingItemAnimation = entity.getHoldingItemAnimationProgress(f2);
        this.right_wing.field_3654 = 0.43633232F;
        this.right_wing.field_3675 = -0.61086524F + f1;
        this.left_wing.field_3654 = 0.43633232F;
        this.left_wing.field_3675 = 0.61086524F - f1;
        float f7 = f4 * 0.6981317F;
        this.body.field_3654 = f7;
        float f8 = class_3532.method_16439(
            holdingItemAnimation,
            f7,
            class_3532.method_16439(f4, (-(float) Math.PI / 3F), (-(float) Math.PI / 4F))
        );
        this.root.field_3656 += (float) Math.cos(f3) * 0.25F * f5;
        this.right_arm.field_3654 = f8;
        this.left_arm.field_3654 = f8;
        float f9 = f5 * (1.0F - holdingItemAnimation);
        float f10 = 0.43633232F
            - class_3532.method_15362(f3 + ((float) Math.PI * 1.5F)) * (float) Math.PI * 0.075F * f9;
        this.left_arm.field_3674 = -f10;
        this.right_arm.field_3674 = f10;
        this.right_arm.field_3675 = 0.27925268F * holdingItemAnimation;
        this.left_arm.field_3675 = -0.27925268F * holdingItemAnimation;
    }

    @Override
    public void method_2828(
        class_4587 stack,
        class_4588 consumer,
        int i,
        int j,
        float f,
        float g,
        float h,
        float k
    ) {
        this.root.method_22698(stack, consumer, i, j);
    }

    @Override
    public void method_2803(class_1306 arm, class_4587 stack) {
        this.root.method_22703(stack);
        this.body.method_22703(stack);
        stack.method_22904(0.0D, -0.09375D, 0.09375D);
        stack.method_22907(class_1160.field_20703.method_23626(this.right_arm.field_3654 + 0.43633232F));
        stack.method_22905(0.7F, 0.7F, 0.7F);
        stack.method_22904(0.0625D, 0.0D, 0.0D);
    }

    @Override
    public class_630 method_32008() {
        return this.root;
    }
}