package com.cursedcauldron.wildbackport.client.render.model;

import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.common.entities.MangroveBoat;
import com.google.common.collect.ImmutableList;
import net.minecraft.class_1690;
import net.minecraft.class_2960;
import net.minecraft.class_3532;
import net.minecraft.class_4595;
import net.minecraft.class_5601;
import net.minecraft.class_5603;
import net.minecraft.class_5606;
import net.minecraft.class_5607;
import net.minecraft.class_5609;
import net.minecraft.class_5610;
import net.minecraft.class_630;

//<>

public class ChestBoatModel extends class_4595<MangroveBoat> {
    private final class_630 leftPaddle;
    private final class_630 rightPaddle;
    private final class_630 waterPatch;
    private final ImmutableList<class_630> parts;

    public ChestBoatModel(class_630 root, boolean chest) {
        this.leftPaddle = root.method_32086("left_paddle");
        this.rightPaddle = root.method_32086("right_paddle");
        this.waterPatch = root.method_32086("water_patch");
        ImmutableList.Builder<class_630> builder = new ImmutableList.Builder<>();
        builder.add(
            root.method_32086("bottom"),
            root.method_32086("back"),
            root.method_32086("front"),
            root.method_32086("right"),
            root.method_32086("left"),
            this.leftPaddle,
            this.rightPaddle
        );
        if (chest) {
            builder.add(root.method_32086("chest_bottom"));
            builder.add(root.method_32086("chest_lid"));
            builder.add(root.method_32086("chest_lock"));
        }

        this.parts = builder.build();
    }

    public static class_5607 createBodyModel(boolean chested) {
        class_5609 mesh = new class_5609();
        class_5610 part = mesh.method_32111();
        part.method_32117(
            "bottom",
            class_5606.method_32108().method_32101(0, 0).method_32097(
                -14.0F, -9.0F, -3.0F, 28.0F, 16.0F, 3.0F
            ),
            class_5603.method_32091(0.0F, 3.0F, 1.0F, 1.5707964F, 0.0F, 0.0F)
        );
        part.method_32117(
            "back",
            class_5606.method_32108().method_32101(0, 19).method_32097(
                -13.0F, -7.0F, -1.0F, 18.0F, 6.0F, 2.0F
            ),
            class_5603.method_32091(-15.0F, 4.0F, 4.0F, 0.0F, 4.712389F, 0.0F)
        );
        part.method_32117(
            "front",
            class_5606.method_32108().method_32101(0, 27).method_32097(
                -8.0F, -7.0F, -1.0F, 16.0F, 6.0F, 2.0F
            ),
            class_5603.method_32091(15.0F, 4.0F, 0.0F, 0.0F, 1.5707964F, 0.0F)
        );
        part.method_32117(
            "right",
            class_5606.method_32108().method_32101(0, 35).method_32097(
                -14.0F, -7.0F, -1.0F, 28.0F, 6.0F, 2.0F
            ),
            class_5603.method_32091(0.0F, 4.0F, -9.0F, 0.0F, 3.1415927F, 0.0F)
        );
        part.method_32117(
            "left",
            class_5606.method_32108().method_32101(0, 43).method_32097(
                -14.0F, -7.0F, -1.0F, 28.0F, 6.0F, 2.0F
            ),
            class_5603.method_32090(0.0F, 4.0F, 9.0F)
        );
        if (chested) {
            part.method_32117(
                "chest_bottom",
                class_5606.method_32108().method_32101(0, 76).method_32097(
                    0.0f, 0.0f, 0.0f, 12.0f, 8.0f, 12.0f
                ),
                class_5603.method_32091(-2.0f, -5.0f, -6.0f, 0.0f, -1.5707964f, 0.0f)
            );
            part.method_32117(
                "chest_lid",
                class_5606.method_32108().method_32101(0, 59).method_32097(
                    0.0f, 0.0f, 0.0f, 12.0f, 4.0f, 12.0f
                ),
                class_5603.method_32091(-2.0f, -9.0f, -6.0f, 0.0f, -1.5707964f, 0.0f)
            );
            part.method_32117(
                "chest_lock",
                class_5606.method_32108().method_32101(0, 59).method_32097(
                    0.0f, 0.0f, 0.0f, 2.0f, 4.0f, 1.0f
                ),
                class_5603.method_32091(-1.0f, -6.0f, -1.0f, 0.0f, -1.5707964f, 0.0f)
            );
        }

        part.method_32117(
            "left_paddle",
            class_5606.method_32108()
                .method_32101(62, 0)
                .method_32097(-1.0F, 0.0F, -5.0F, 2.0F, 2.0F, 18.0F)
                .method_32097(-1.001F, -3.0F, 8.0F, 1.0F, 6.0F, 7.0F),
            class_5603.method_32091(3.0F, -5.0F, 9.0F, 0.0F, 0.0F, 0.19634955F)
        );
        part.method_32117(
            "right_paddle",
            class_5606.method_32108()
                .method_32101(62, 20)
                .method_32097(-1.0F, 0.0F, -5.0F, 2.0F, 2.0F, 18.0F)
                .method_32097(0.001F, -3.0F, 8.0F, 1.0F, 6.0F, 7.0F),
            class_5603.method_32091(3.0F, -5.0F, -9.0F, 0.0F, 3.1415927F, 0.19634955F)
        );
        part.method_32117(
            "water_patch",
            class_5606.method_32108().method_32101(0, 0).method_32097(
                -14.0F, -9.0F, -3.0F, 28.0F, 16.0F, 3.0F
            ),
            class_5603.method_32091(0.0F, -3.0F, 1.0F, 1.5707964F, 0.0F, 0.0F)
        );
        return class_5607.method_32110(mesh, 128, chested ? 128 : 64);
    }

    @Override
    public void setupAnim(
        MangroveBoat boat,
        float angle,
        float distance,
        float animationProgress,
        float yaw,
        float pitch
    ) {
        animatePaddle(boat, 0, this.leftPaddle, angle);
        animatePaddle(boat, 1, this.rightPaddle, angle);
    }

    public ImmutableList<class_630> method_22960() {
        return this.parts;
    }

    public class_630 waterPatch() {
        return this.waterPatch;
    }

    private static void
    animatePaddle(MangroveBoat boat, int sigma, class_630 part, float angle) {
        float time = boat.method_7551(sigma, angle);
        part.field_3654
            = class_3532.method_37166(-1.0471976F, -0.2617994F, (class_3532.method_15374(-time) + 1.0F) / 2.0F);
        part.field_3675 = class_3532.method_37166(
            -0.7853982F, 0.7853982F, (class_3532.method_15374(-time + 1.0F) + 1.0F) / 2.0F
        );
        if (sigma == 1)
            part.field_3675 = (float) Math.PI - part.field_3675;
    }

    public static class_5601 createChestBoat(class_1690.class_1692 type) {
        return new class_5601(
            new class_2960("chest_boat/" + type.method_7559()), "main"
        );
    }
}