package com.cursedcauldron.wildbackport.client.render.model;

import com.cursedcauldron.wildbackport.client.animation.FrogAnimations;
import com.cursedcauldron.wildbackport.client.animation.api.Animated;
import com.cursedcauldron.wildbackport.client.animation.api.AnimatedModel;
import com.cursedcauldron.wildbackport.common.entities.Frog;
import net.minecraft.class_5603;
import net.minecraft.class_5605;
import net.minecraft.class_5606;
import net.minecraft.class_5607;
import net.minecraft.class_5609;
import net.minecraft.class_5610;
import net.minecraft.class_630;

public class FrogModel<T extends Frog> extends AnimatedModel<T> {
    private final class_630 root;
    private final class_630 body;
    private final class_630 head;
    private final class_630 eyes;
    private final class_630 tongue;
    private final class_630 leftArm;
    private final class_630 rightArm;
    private final class_630 leftLeg;
    private final class_630 rightLeg;
    private final class_630 croakingBody;

    public FrogModel(class_630 root) {
        this.root = root.method_32086("root");
        this.body = this.root.method_32086("body");
        this.head = this.body.method_32086("head");
        this.eyes = this.head.method_32086("eyes");
        this.tongue = this.body.method_32086("tongue");
        this.leftArm = this.body.method_32086("left_arm");
        this.rightArm = this.body.method_32086("right_arm");
        this.leftLeg = this.root.method_32086("left_leg");
        this.rightLeg = this.root.method_32086("right_leg");
        this.croakingBody = this.body.method_32086("croaking_body");
    }

    public static class_5607 createBodyLayer() {
        class_5609 mesh = new class_5609();
        class_5610 root = mesh.method_32111();
        class_5610 bone = root.method_32117(
            "root", class_5606.method_32108(), class_5603.method_32090(0.0f, 24.0f, 0.0f)
        );
        class_5610 body = bone.method_32117(
            "body",
            class_5606.method_32108()
                .method_32101(3, 1)
                .method_32097(-3.5f, -2.0f, -8.0f, 7.0f, 3.0f, 9.0f)
                .method_32101(23, 22)
                .method_32097(-3.5f, -1.0f, -8.0f, 7.0f, 0.0f, 9.0f),
            class_5603.method_32090(0.0f, -2.0f, 4.0f)
        );
        class_5610 head = body.method_32117(
            "head",
            class_5606.method_32108()
                .method_32101(23, 13)
                .method_32097(-3.5f, -1.0f, -7.0f, 7.0f, 0.0f, 9.0f)
                .method_32101(0, 13)
                .method_32097(-3.5f, -2.0f, -7.0f, 7.0f, 3.0f, 9.0f),
            class_5603.method_32090(0.0f, -2.0f, -1.0f)
        );
        class_5610 eyes = head.method_32117(
            "eyes", class_5606.method_32108(), class_5603.method_32090(-0.5f, 0.0f, 2.0f)
        );
        eyes.method_32117(
            "right_eye",
            class_5606.method_32108().method_32101(0, 0).method_32097(
                -1.5f, -1.0f, -1.5f, 3.0f, 2.0f, 3.0f
            ),
            class_5603.method_32090(-1.5f, -3.0f, -6.5f)
        );
        eyes.method_32117(
            "left_eye",
            class_5606.method_32108().method_32101(0, 5).method_32097(
                -1.5f, -1.0f, -1.5f, 3.0f, 2.0f, 3.0f
            ),
            class_5603.method_32090(2.5f, -3.0f, -6.5f)
        );
        body.method_32117(
            "croaking_body",
            class_5606.method_32108().method_32101(26, 5).method_32098(
                -3.5f, -0.1f, -2.9f, 7.0f, 2.0f, 3.0f, new class_5605(-0.1f)
            ),
            class_5603.method_32090(0.0f, -1.0f, -5.0f)
        );
        body.method_32117(
            "tongue",
            class_5606.method_32108().method_32101(17, 13).method_32097(
                -2.0f, 0.0f, -7.1f, 4.0f, 0.0f, 7.0f
            ),
            class_5603.method_32090(0.0f, -1.01f, 1.0f)
        );
        class_5610 left_arm = body.method_32117(
            "left_arm",
            class_5606.method_32108().method_32101(0, 32).method_32097(
                -1.0f, 0.0f, -1.0f, 2.0f, 3.0f, 3.0f
            ),
            class_5603.method_32090(4.0f, -1.0f, -6.5f)
        );
        left_arm.method_32117(
            "left_hand",
            class_5606.method_32108().method_32101(18, 40).method_32097(
                -4.0f, 0.01f, -4.0f, 8.0f, 0.0f, 8.0f
            ),
            class_5603.method_32090(0.0f, 3.0f, -1.0f)
        );
        class_5610 right_arm = body.method_32117(
            "right_arm",
            class_5606.method_32108().method_32101(0, 38).method_32097(
                -1.0f, 0.0f, -1.0f, 2.0f, 3.0f, 3.0f
            ),
            class_5603.method_32090(-4.0f, -1.0f, -6.5f)
        );
        right_arm.method_32117(
            "right_hand",
            class_5606.method_32108().method_32101(2, 40).method_32097(
                -4.0f, 0.01f, -5.0f, 8.0f, 0.0f, 8.0f
            ),
            class_5603.method_32090(0.0f, 3.0f, 0.0f)
        );
        class_5610 left_leg = bone.method_32117(
            "left_leg",
            class_5606.method_32108().method_32101(14, 25).method_32097(
                -1.0f, 0.0f, -2.0f, 3.0f, 3.0f, 4.0f
            ),
            class_5603.method_32090(3.5f, -3.0f, 4.0f)
        );
        left_leg.method_32117(
            "left_foot",
            class_5606.method_32108().method_32101(2, 32).method_32097(
                -4.0f, 0.01f, -4.0f, 8.0f, 0.0f, 8.0f
            ),
            class_5603.method_32090(2.0f, 3.0f, 0.0f)
        );
        class_5610 right_leg = bone.method_32117(
            "right_leg",
            class_5606.method_32108().method_32101(0, 25).method_32097(
                -2.0f, 0.0f, -2.0f, 3.0f, 3.0f, 4.0f
            ),
            class_5603.method_32090(-3.5f, -3.0f, 4.0f)
        );
        right_leg.method_32117(
            "right_foot",
            class_5606.method_32108().method_32101(18, 32).method_32097(
                -4.0f, 0.01f, -4.0f, 8.0f, 0.0f, 8.0f
            ),
            class_5603.method_32090(-2.0f, 3.0f, 0.0f)
        );
        return class_5607.method_32110(mesh, 48, 48);
    }

    @Override
    public void setupAnim(
        T entity,
        float angle,
        float distance,
        float animationProgress,
        float yaw,
        float pitch
    ) {
        this.root.method_32088().forEach(Animated::resetToDefault);
        float speedMultiplier
            = Math.min((float) entity.method_18798().method_1027() * 200.0F, 8.0F);
        this.animate(
            entity.longJumpingAnimationState,
            FrogAnimations.LONG_JUMPING,
            animationProgress
        );
        this.animate(
            entity.croakingAnimationState, FrogAnimations.CROAKING, animationProgress
        );
        this.animate(
            entity.usingTongueAnimationState,
            FrogAnimations.USING_TONGUE,
            animationProgress
        );
        this.animate(
            entity.walkingAnimationState,
            FrogAnimations.WALKING,
            animationProgress,
            speedMultiplier
        );
        this.animate(
            entity.swimmingAnimationState, FrogAnimations.SWIMMING, animationProgress
        );
        this.animate(
            entity.idlingInWaterAnimationState,
            FrogAnimations.IDLING_IN_WATER,
            animationProgress
        );
        this.croakingBody.field_3665 = entity.croakingAnimationState.isRunning();
    }

    @Override
    public class_630 method_32008() {
        return this.root;
    }
}
