package com.cursedcauldron.wildbackport.client.render.model;

import java.util.List;
import net.minecraft.class_1921;
import net.minecraft.class_3532;
import net.minecraft.class_5603;
import net.minecraft.class_5606;
import net.minecraft.class_5607;
import net.minecraft.class_5609;
import net.minecraft.class_5610;
import net.minecraft.class_630;
import com.cursedcauldron.wildbackport.client.animation.WardenAnimations;
import com.cursedcauldron.wildbackport.client.animation.api.Animated;
import com.cursedcauldron.wildbackport.client.animation.api.AnimatedModel;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.google.common.collect.ImmutableList;

//<>

public class WardenModel<T extends Warden> extends AnimatedModel<T> {
    private final class_630 root;
    protected final class_630 bone;
    protected final class_630 body;
    protected final class_630 head;
    protected final class_630 rightTendril;
    protected final class_630 leftTendril;
    protected final class_630 leftLeg;
    protected final class_630 leftArm;
    protected final class_630 leftRibcage;
    protected final class_630 rightArm;
    protected final class_630 rightLeg;
    protected final class_630 rightRibcage;
    private final List<class_630> tendrils;
    private final List<class_630> justBody;
    private final List<class_630> headAndLimbs;
    private final List<class_630> bodyHeadAndLimbs;

    public WardenModel(class_630 root) {
        super(class_1921::method_23578);
        this.root = root;
        this.bone = root.method_32086("bone");
        this.body = this.bone.method_32086("body");
        this.head = this.body.method_32086("head");
        this.rightLeg = this.bone.method_32086("right_leg");
        this.leftLeg = this.bone.method_32086("left_leg");
        this.rightArm = this.body.method_32086("right_arm");
        this.leftArm = this.body.method_32086("left_arm");
        this.rightTendril = this.head.method_32086("right_tendril");
        this.leftTendril = this.head.method_32086("left_tendril");
        this.rightRibcage = this.body.method_32086("right_ribcage");
        this.leftRibcage = this.body.method_32086("left_ribcage");
        this.tendrils = ImmutableList.of(this.leftTendril, this.rightTendril);
        this.justBody = ImmutableList.of(this.body);
        this.headAndLimbs = ImmutableList.of(
            this.head, this.leftArm, this.rightArm, this.leftLeg, this.rightLeg
        );
        this.bodyHeadAndLimbs = ImmutableList.of(
            this.body, this.head, this.leftArm, this.rightArm, this.leftLeg, this.rightLeg
        );
    }

    public static class_5607 createBodyLayer() {
        class_5609 mesh = new class_5609();
        class_5610 root = mesh.method_32111();
        class_5610 bone = root.method_32117(
            "bone", class_5606.method_32108(), class_5603.method_32090(0.0f, 24.0f, 0.0f)
        );
        class_5610 body = bone.method_32117(
            "body",
            class_5606.method_32108().method_32101(0, 0).method_32097(
                -9.0f, -13.0f, -4.0f, 18.0f, 21.0f, 11.0f
            ),
            class_5603.method_32090(0.0f, -21.0f, 0.0f)
        );
        body.method_32117(
            "right_ribcage",
            class_5606.method_32108().method_32101(90, 11).method_32097(
                -2.0f, -11.0f, -0.1f, 9.0f, 21.0f, 0.0f
            ),
            class_5603.method_32090(-7.0f, -2.0f, -4.0f)
        );
        body.method_32117(
            "left_ribcage",
            class_5606.method_32108()
                .method_32101(90, 11)
                .method_32096()
                .method_32097(-7.0f, -11.0f, -0.1f, 9.0f, 21.0f, 0.0f)
                .method_32106(false),
            class_5603.method_32090(7.0f, -2.0f, -4.0f)
        );
        class_5610 head = body.method_32117(
            "head",
            class_5606.method_32108().method_32101(0, 32).method_32097(
                -8.0f, -16.0f, -5.0f, 16.0f, 16.0f, 10.0f
            ),
            class_5603.method_32090(0.0f, -13.0f, 0.0f)
        );
        head.method_32117(
            "right_tendril",
            class_5606.method_32108().method_32101(52, 32).method_32097(
                -16.0f, -13.0f, 0.0f, 16.0f, 16.0f, 0.0f
            ),
            class_5603.method_32090(-8.0f, -12.0f, 0.0f)
        );
        head.method_32117(
            "left_tendril",
            class_5606.method_32108().method_32101(58, 0).method_32097(
                0.0f, -13.0f, 0.0f, 16.0f, 16.0f, 0.0f
            ),
            class_5603.method_32090(8.0f, -12.0f, 0.0f)
        );
        body.method_32117(
            "right_arm",
            class_5606.method_32108().method_32101(44, 50).method_32097(
                -4.0f, 0.0f, -4.0f, 8.0f, 28.0f, 8.0f
            ),
            class_5603.method_32090(-13.0f, -13.0f, 1.0f)
        );
        body.method_32117(
            "left_arm",
            class_5606.method_32108().method_32101(0, 58).method_32097(
                -4.0f, 0.0f, -4.0f, 8.0f, 28.0f, 8.0f
            ),
            class_5603.method_32090(13.0f, -13.0f, 1.0f)
        );
        bone.method_32117(
            "right_leg",
            class_5606.method_32108().method_32101(76, 48).method_32097(
                -3.1f, 0.0f, -3.0f, 6.0f, 13.0f, 6.0f
            ),
            class_5603.method_32090(-5.9f, -13.0f, 0.0f)
        );
        bone.method_32117(
            "left_leg",
            class_5606.method_32108().method_32101(76, 76).method_32097(
                -2.9f, 0.0f, -3.0f, 6.0f, 13.0f, 6.0f
            ),
            class_5603.method_32090(5.9f, -13.0f, 0.0f)
        );
        return class_5607.method_32110(mesh, 128, 128);
    }

    @Override
    public void setupAnim(
        T entity,
        float angle,
        float distance,
        float animationProgress,
        float yaw,
        float pitch
    ) {
        this.root.method_32088().forEach(Animated::resetToDefault);
        float tickDelta = animationProgress - (float) entity.field_6012;
        this.setHeadAngle(yaw, pitch);
        this.setLimbAngles(angle, distance);
        this.setHeadAndBodyAngles(animationProgress);
        this.setTendrilPitches(entity, animationProgress, tickDelta);
        this.animate(
            entity.attackingAnimationState, WardenAnimations.ATTACKING, animationProgress
        );
        this.animate(
            entity.sonicBoomAnimationState, WardenAnimations.SONIC_BOOM, animationProgress
        );
        this.animate(
            entity.diggingAnimationState, WardenAnimations.DIGGING, animationProgress
        );
        this.animate(
            entity.emergingAnimationState, WardenAnimations.EMERGING, animationProgress
        );
        this.animate(
            entity.roaringAnimationState, WardenAnimations.ROARING, animationProgress
        );
        this.animate(
            entity.sniffingAnimationState, WardenAnimations.SNIFFING, animationProgress
        );
    }

    private void setHeadAngle(float yaw, float pitch) {
        this.head.field_3654 = pitch * ((float) Math.PI / 180);
        this.head.field_3675 = yaw * ((float) Math.PI / 180);
    }

    private void setHeadAndBodyAngles(float animationProgress) {
        float angle = animationProgress * 0.1F;
        float cos = class_3532.method_15362(angle);
        float sin = class_3532.method_15374(angle);
        this.head.field_3674 += 0.06F * cos;
        this.head.field_3654 += 0.06F * sin;
        this.body.field_3674 += 0.025F * sin;
        this.body.field_3654 += 0.025F * cos;
    }

    private void setLimbAngles(float angle, float distance) {
        float roll = Math.min(0.5F, 3.0F * distance);
        float mod = angle * 0.8662F;
        float cos = class_3532.method_15362(mod);
        float sin = class_3532.method_15374(mod);
        float pitch = Math.min(0.35F, roll);
        this.head.field_3674 += 0.3F * sin * roll;
        this.head.field_3654 += 1.2F * class_3532.method_15362(mod + 1.5707964F) * pitch;
        this.body.field_3674 = 0.1F * sin * roll;
        this.body.field_3654 = 1.0F * cos * pitch;
        this.leftLeg.field_3654 = 1.0F * cos * roll;
        this.rightLeg.field_3654 = 1.0F * class_3532.method_15362(mod + (float) Math.PI) * roll;
        this.leftArm.field_3654 = -(0.8F * cos * roll);
        this.leftArm.field_3674 = 0.0F;
        this.rightArm.field_3654 = -(0.8F * sin * roll);
        this.rightArm.field_3674 = 0.0F;
        this.setArmPivots();
    }

    private void setArmPivots() {
        this.leftArm.field_3675 = 0.0F;
        this.leftArm.field_3655 = 1.0F;
        this.leftArm.field_3657 = 13.0F;
        this.leftArm.field_3656 = -13.0F;
        this.rightArm.field_3675 = 0.0F;
        this.rightArm.field_3655 = 1.0F;
        this.rightArm.field_3657 = -13.0F;
        this.rightArm.field_3656 = -13.0F;
    }

    private void setTendrilPitches(T warden, float animationProgress, float tickDelta) {
        float pitch = warden.getTendrilPitch(tickDelta)
            * (float
            ) (Math.cos((double) animationProgress * 2.25D) * Math.PI * (double) 0.1F);
        this.leftTendril.field_3654 = pitch;
        this.rightTendril.field_3654 = -pitch;
    }

    @Override
    public class_630 method_32008() {
        return this.root;
    }

    public List<class_630> getTendrils() {
        return this.tendrils;
    }

    public List<class_630> getBody() {
        return this.justBody;
    }

    public List<class_630> getHeadAndLimbs() {
        return this.headAndLimbs;
    }

    public List<class_630> getBodyHeadAndLimbs() {
        return this.bodyHeadAndLimbs;
    }
}