package com.cursedcauldron.wildbackport.common;

import com.cursedcauldron.wildbackport.common.registry.WBBlocks;
import com.cursedcauldron.wildbackport.common.tag.WBBlockTags;
import com.cursedcauldron.wildbackport.core.api.event.Interactions;
import com.cursedcauldron.wildbackport.core.mixin.access.AxeItemAccessor;
import com.cursedcauldron.wildbackport.core.mixin.access.FireBlockAccessor;
import com.google.common.collect.Maps;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1844;
import net.minecraft.class_1847;
import net.minecraft.class_1935;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2315;
import net.minecraft.class_2338;
import net.minecraft.class_2342;
import net.minecraft.class_2347;
import net.minecraft.class_2350;
import net.minecraft.class_2398;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3468;
import net.minecraft.class_3962;
import net.minecraft.class_5328;
import net.minecraft.class_5712;

public class VanillaIntegration {
    public static void setup() {
        // Flammables
        addFlammable(WBBlocks.MANGROVE_LOG.get(), 5, 5);
        addFlammable(WBBlocks.MANGROVE_WOOD.get(), 5, 5);
        addFlammable(WBBlocks.STRIPPED_MANGROVE_LOG.get(), 5, 5);
        addFlammable(WBBlocks.STRIPPED_MANGROVE_WOOD.get(), 5, 5);
        addFlammable(WBBlocks.MANGROVE_PLANKS.get(), 5, 20);
        addFlammable(WBBlocks.MANGROVE_STAIRS.get(), 5, 20);
        addFlammable(WBBlocks.MANGROVE_SLAB.get(), 5, 20);
        addFlammable(WBBlocks.MANGROVE_FENCE.get(), 5, 20);
        addFlammable(WBBlocks.MANGROVE_FENCE_GATE.get(), 5, 20);
        addFlammable(WBBlocks.MANGROVE_ROOTS.get(), 5, 20);
        addFlammable(WBBlocks.MANGROVE_LEAVES.get(), 30, 60);

        // Compostables
        addCompostable(WBBlocks.MANGROVE_LEAVES.get(), 0.3F);
        addCompostable(WBBlocks.MANGROVE_PROPAGULE.get(), 0.3F);
        addCompostable(WBBlocks.MANGROVE_ROOTS.get(), 0.3F);

        // Strippables
        addStrippable(WBBlocks.MANGROVE_LOG.get(), WBBlocks.STRIPPED_MANGROVE_LOG.get());
        addStrippable(
            WBBlocks.MANGROVE_WOOD.get(), WBBlocks.STRIPPED_MANGROVE_WOOD.get()
        );

        // Turning Dirt into Mud
        Interactions.addRightClick(context -> {
            class_1937 level = context.method_8045();
            class_2338 pos = context.method_8037();
            class_1657 player = context.method_8036();
            class_1799 stack = context.method_8041();
            class_2680 state = level.method_8320(pos);
            if (player != null && context.method_8038() != class_2350.field_11033
                && state.method_26164(WBBlockTags.CONVERTABLE_TO_MUD)
                && class_1844.method_8063(stack) == class_1847.field_8991) {
                level.method_8396(
                    null, pos, class_3417.field_14737, class_3419.field_15248, 1.0F, 1.0F
                );
                player.method_6122(
                    context.method_20287(),
                    class_5328.method_30012(
                        stack, player, new class_1799(class_1802.field_8469)
                    )
                );
                player.method_7259(class_3468.field_15372.method_14956(stack.method_7909()));

                if (!level.method_8608()) {
                    for (int i = 0; i < 5; i++) {
                        ((class_3218) level)
                            .method_14199(
                                class_2398.field_11202,
                                (double) pos.method_10263() + level.field_9229.nextDouble(),
                                pos.method_10264() + 1,
                                (double) pos.method_10260() + level.field_9229.nextDouble(),
                                1,
                                0.0D,
                                0.0D,
                                0.0D,
                                1.0D
                            );
                    }
                }

                level.method_8396(
                    null, pos, class_3417.field_14826, class_3419.field_15245, 1.0F, 1.0F
                );
                level.method_32889(class_5712.field_28166, pos);
                level.method_8501(pos, WBBlocks.MUD.get().method_9564());
                return class_1269.method_29236(level.method_8608());
            } else {
                return class_1269.field_5811;
            }
        });

        class_2315.method_10009(class_1802.field_8574, new class_2347() {
            private final class_2347 behavior
                = new class_2347();

            @Override
            protected class_1799 method_10135(class_2342 source, class_1799 stack) {
                if (class_1844.method_8063(stack) != class_1847.field_8991) {
                    return this.behavior.dispense(source, stack);
                } else {
                    class_3218 level = source.method_10207();
                    class_2338 sourcePos = source.method_10122();
                    class_2338 dispenserPos = source.method_10122().method_10093(
                        source.method_10120().method_11654(class_2315.field_10918)
                    );
                    if (!level.method_8320(dispenserPos)
                             .method_26164(WBBlockTags.CONVERTABLE_TO_MUD)) {
                        return this.behavior.dispense(source, stack);
                    } else {
                        if (!level.method_8608()) {
                            for (int i = 0; i < 5; i++) {
                                level.method_14199(
                                    class_2398.field_11202,
                                    (double) sourcePos.method_10263() + level.field_9229.nextDouble(),
                                    sourcePos.method_10264() + 1,
                                    (double) sourcePos.method_10260() + level.field_9229.nextDouble(),
                                    1,
                                    0.0D,
                                    0.0D,
                                    0.0D,
                                    1.0D
                                );
                            }
                        }

                        level.method_8396(
                            null,
                            sourcePos,
                            class_3417.field_14826,
                            class_3419.field_15245,
                            1.0F,
                            1.0F
                        );
                        level.method_32889(class_5712.field_28166, sourcePos);
                        level.method_8501(
                            dispenserPos, WBBlocks.MUD.get().method_9564()
                        );
                        return new class_1799(class_1802.field_8469);
                    }
                }
            }
        });
    }

    public static void addFlammable(class_2248 block, int flameOdds, int burnOdds) {
        ((FireBlockAccessor) class_2246.field_10036).callSetFlammable(block, flameOdds, burnOdds);
    }

    public static void addCompostable(class_1935 item, float chance) {
        class_3962.field_17566.put(item.method_8389(), chance);
    }

    public static void addStrippable(class_2248 from, class_2248 to) {
        AxeItemAccessor.setSTRIPPABLES(Maps.newHashMap(AxeItemAccessor.getSTRIPPABLES()));
        AxeItemAccessor.getSTRIPPABLES().put(from, to);
    }
}