package com.cursedcauldron.wildbackport.common.blocks;

import java.util.Random;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3419;
import net.minecraft.class_3532;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_4538;
import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.entities.Tadpole;
import com.cursedcauldron.wildbackport.common.registry.entity.WBEntityTypes;

//<>

public class FrogspawnBlock extends class_2248 {
    protected static final class_265 SHAPE
        = class_2248.method_9541(0.0D, 0.0D, 0.0D, 16.0D, 1.5D, 16.0D);

    public FrogspawnBlock(class_2251 properties) {
        super(properties);
    }

    @Override
    public class_265 method_9530(
        class_2680 state, class_1922 getter, class_2338 pos, class_3726 context
    ) {
        return SHAPE;
    }

    @Override
    public boolean method_9558(class_2680 state, class_4538 reader, class_2338 pos) {
        return mayPlaceOn(reader, pos.method_10074());
    }

    @Override
    public void method_9615(
        class_2680 state, class_1937 level, class_2338 pos, class_2680 oldState, boolean notify
    ) {
        level.method_39279(pos, this, hatchTime(level.method_8409()));
    }

    private static int hatchTime(Random random) {
        return random.nextInt(3600, 12000);
    }

    @Override
    public class_2680 method_9559(
        class_2680 state,
        class_2350 direction,
        class_2680 neighborState,
        class_1936 access,
        class_2338 pos,
        class_2338 neighborPos
    ) {
        return !this.method_9558(state, access, pos)
            ? class_2246.field_10124.method_9564()
            : super.method_9559(
                state, direction, neighborState, access, pos, neighborPos
            );
    }

    @Override
    public void method_9588(class_2680 state, class_3218 level, class_2338 pos, Random random) {
        if (!this.method_9558(state, level, pos)) {
            this.hatch(level, pos);
        } else {
            this.onHatch(level, pos, random);
        }
    }

    @Override
    public void method_9548(class_2680 state, class_1937 level, class_2338 pos, class_1297 entity) {
        if (entity.method_5864().equals(class_1299.field_6089)) {
            this.hatch(level, pos);
        }
    }

    private static boolean mayPlaceOn(class_4538 reader, class_2338 pos) {
        class_3610 fluidState = reader.method_8316(pos);
        class_3610 topFluidState = reader.method_8316(pos.method_10084());
        return fluidState.method_15772() == class_3612.field_15910
            && topFluidState.method_15772() == class_3612.field_15906;
    }

    private void onHatch(class_3218 level, class_2338 pos, Random random) {
        this.hatch(level, pos);
        level.method_8396(
            null, pos, WBSoundEvents.BLOCK_FROGSPAWN_HATCH, class_3419.field_15245, 1.0F, 1.0F
        );
        this.createTadpole(level, pos, random);
    }

    private void hatch(class_1937 level, class_2338 blockPos) {
        level.method_22352(blockPos, false);
    }

    private void createTadpole(class_3218 level, class_2338 pos, Random random) {
        int i = random.nextInt(2, 6);

        for (int index = 1; index <= i; ++index) {
            Tadpole tadpole = WBEntityTypes.TADPOLE.get().method_5883(level);
            if (tadpole != null) {
                double x = (double) pos.method_10263() + this.getSpawnOffset(random);
                double z = (double) pos.method_10260() + this.getSpawnOffset(random);
                int yaw = random.nextInt(1, 361);
                tadpole.method_5808(x, (double) pos.method_10264() - 0.5, z, yaw, 0.0F);
                tadpole.method_5971();
                level.method_8649(tadpole);
            }
        }
    }

    private double getSpawnOffset(Random random) {
        return class_3532.method_15350(random.nextDouble(), 0.2F, 0.8F);
    }
}