package com.cursedcauldron.wildbackport.common.blocks;

import java.util.Random;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2473;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_2758;
import net.minecraft.class_3218;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_4538;
import com.cursedcauldron.wildbackport.common.registry.WBBlocks;
import org.jetbrains.annotations.Nullable;

//<>

public class MangrovePropaguleBlock
    extends class_2473 implements class_3737 {
    private static final class_265[] SHAPES
        = new class_265[] { class_2248.method_9541(7.0D, 13.0D, 7.0D, 9.0D, 16.0D, 9.0D),
                             class_2248.method_9541(7.0D, 10.0D, 7.0D, 9.0D, 16.0D, 9.0D),
                             class_2248.method_9541(7.0D, 7.0D, 7.0D, 9.0D, 16.0D, 9.0D),
                             class_2248.method_9541(7.0D, 3.0D, 7.0D, 9.0D, 16.0D, 9.0D),
                             class_2248.method_9541(7.0D, 0.0D, 7.0D, 9.0D, 16.0D, 9.0D) };
    public static final class_2758 AGE = StateProperties.AGE_4;
    public static final class_2746 WATERLOGGED = class_2741.field_12508;
    public static final class_2746 HANGING = class_2741.field_16561;

    public MangrovePropaguleBlock(class_2251 properties) {
        super(new MangroveTreeGrower(0.85F), properties);
        this.method_9590(this.field_10647.method_11664()
                                      .method_11657(field_11476, 0)
                                      .method_11657(AGE, 0)
                                      .method_11657(WATERLOGGED, false)
                                      .method_11657(HANGING, false));
    }

    @Override
    protected void
    method_9515(class_2689.class_2690<class_2248, class_2680> builder) {
        builder.method_11667(field_11476, AGE, WATERLOGGED, HANGING);
    }

    @Override
    protected boolean method_9695(class_2680 state, class_1922 block, class_2338 pos) {
        return super.method_9695(state, block, pos) || state.method_27852(class_2246.field_10460);
    }

    @Override
    @Nullable
    @SuppressWarnings("ConstantConditions")
    public class_2680 method_9605(class_1750 ctx) {
        class_3610 fluidState = ctx.method_8045().method_8316(ctx.method_8037());
        return super.method_9605(ctx)
            .method_11657(WATERLOGGED, fluidState.method_15772() == class_3612.field_15910)
            .method_11657(AGE, 4);
    }

    @Override
    public class_265 method_9530(
        class_2680 state, class_1922 block, class_2338 pos, class_3726 context
    ) {
        class_243 offset = state.method_26226(block, pos);
        class_265 shape
            = !state.method_11654(HANGING) ? SHAPES[4] : SHAPES[state.method_11654(AGE)];
        return shape.method_1096(offset.field_1352, offset.field_1351, offset.field_1350);
    }

    @Override
    public boolean method_9558(class_2680 state, class_4538 level, class_2338 pos) {
        return isHanging(state)
            ? level.method_8320(pos.method_10084()).method_27852(WBBlocks.MANGROVE_LEAVES.get())
            : super.method_9558(state, level, pos);
    }

    @Override
    public class_2680 method_9559(
        class_2680 state,
        class_2350 direction,
        class_2680 newState,
        class_1936 level,
        class_2338 pos,
        class_2338 newPos
    ) {
        if (state.method_11654(WATERLOGGED))
            level.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(level));
        return direction == class_2350.field_11036 && !state.method_26184(level, pos)
            ? class_2246.field_10124.method_9564()
            : super.method_9559(state, direction, newState, level, pos, newPos);
    }

    @Override
    public class_2250 method_16841() {
        return class_2250.field_10657;
    }

    @Override
    public class_3610 method_9545(class_2680 state) {
        return state.method_11654(WATERLOGGED) ? class_3612.field_15910.method_15729(false)
                                           : super.method_9545(state);
    }

    @Override
    public void
    method_9514(class_2680 state, class_3218 level, class_2338 pos, Random random) {
        if (!isHanging(state)) {
            if (random.nextInt(7) == 0)
                this.method_10507(level, pos, state, random);
        } else {
            if (!ageAtMax(state))
                level.method_8652(pos, state.method_28493(AGE), 2);
        }
    }

    @Override
    public boolean method_9651(
        class_1922 block, class_2338 pos, class_2680 state, boolean flag
    ) {
        return !isHanging(state) || !ageAtMax(state);
    }

    @Override
    public boolean
    method_9650(class_1937 level, Random random, class_2338 pos, class_2680 state) {
        return isHanging(state) ? !ageAtMax(state)
                                : super.method_9650(level, random, pos, state);
    }

    @Override
    public void
    method_9652(class_3218 level, Random random, class_2338 pos, class_2680 state) {
        if (isHanging(state) && !ageAtMax(state)) {
            level.method_8652(pos, state.method_28493(AGE), 2);
        } else {
            super.method_9652(level, random, pos, state);
        }
    }

    private static boolean isHanging(class_2680 state) {
        return state.method_11654(HANGING);
    }

    private static boolean ageAtMax(class_2680 state) {
        return state.method_11654(AGE) == 4;
    }

    public static class_2680 createPropagule() {
        return createPropagule(0);
    }

    public static class_2680 createPropagule(int age) {
        return WBBlocks.MANGROVE_PROPAGULE.get()
            .method_9564()
            .method_11657(HANGING, true)
            .method_11657(AGE, age);
    }
}