package com.cursedcauldron.wildbackport.common.blocks;

import java.util.Random;
import net.minecraft.class_1297;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1890;
import net.minecraft.class_1893;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2237;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2464;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_5558;
import net.minecraft.class_5714;
import com.cursedcauldron.wildbackport.common.blocks.entity.SculkShriekerBlockEntity;
import com.cursedcauldron.wildbackport.common.registry.WBBlockEntities;
import org.jetbrains.annotations.Nullable;

//<>

public class SculkShriekerBlock
    extends class_2237 implements class_3737 {
    public static final class_2746 SHRIEKING = StateProperties.SHRIEKING;
    public static final class_2746 CAN_SUMMON = StateProperties.CAN_SUMMON;
    public static final class_2746 WATERLOGGED = class_2741.field_12508;
    private static final class_265 SHAPE
        = class_2248.method_9541(0.0D, 0.0D, 0.0D, 16.0D, 8.0D, 16.0D);
    public static final double TOP_Y = SHAPE.method_1105(class_2350.class_2351.field_11052);

    public SculkShriekerBlock(class_2251 properties) {
        super(properties);
        this.method_9590(this.field_10647.method_11664()
                                      .method_11657(SHRIEKING, false)
                                      .method_11657(WATERLOGGED, false)
                                      .method_11657(CAN_SUMMON, false));
    }

    @Override
    protected void
    method_9515(class_2689.class_2690<class_2248, class_2680> builder) {
        builder.method_11667(SHRIEKING, WATERLOGGED, CAN_SUMMON);
    }

    @Override
    public void method_9591(class_1937 level, class_2338 pos, class_2680 state, class_1297 entity) {
        if (level instanceof class_3218 server) {
            class_3222 player = SculkShriekerBlockEntity.tryGetPlayer(entity);
            if (player != null) {
                server.method_35230(pos, WBBlockEntities.SCULK_SHRIEKER.get())
                    .ifPresent(shrieker -> shrieker.tryShriek(server, player));
            }
        }

        super.method_9591(level, pos, state, entity);
    }

    @Override
    public void method_9536(
        class_2680 state, class_1937 level, class_2338 pos, class_2680 newState, boolean moving
    ) {
        if (level instanceof class_3218 server) {
            if (state.method_11654(SHRIEKING) && !state.method_27852(newState.method_26204())) {
                server.method_35230(pos, WBBlockEntities.SCULK_SHRIEKER.get())
                    .ifPresent(shrieker -> shrieker.tryRespond(server));
            }
        }

        super.method_9536(state, level, pos, newState, moving);
    }

    @Override
    public void method_9588(class_2680 state, class_3218 level, class_2338 pos, Random random) {
        if (state.method_11654(SHRIEKING)) {
            level.method_8652(pos, state.method_11657(SHRIEKING, false), 3);
            level.method_35230(pos, WBBlockEntities.SCULK_SHRIEKER.get())
                .ifPresent(shrieker -> shrieker.tryRespond(level));
        }
    }

    @Override
    public class_2464 method_9604(class_2680 state) {
        return class_2464.field_11458;
    }

    @Override
    public class_265 method_9549(
        class_2680 state, class_1922 getter, class_2338 pos, class_3726 context
    ) {
        return SHAPE;
    }

    @Override
    public class_265
    method_9571(class_2680 state, class_1922 getter, class_2338 pos) {
        return SHAPE;
    }

    @Override
    public boolean method_9526(class_2680 state) {
        return true;
    }

    @Nullable
    @Override
    public class_2586 method_10123(class_2338 pos, class_2680 state) {
        return new SculkShriekerBlockEntity(pos, state);
    }

    @Override
    public class_2680 method_9559(
        class_2680 state,
        class_2350 direction,
        class_2680 newState,
        class_1936 level,
        class_2338 pos,
        class_2338 newPos
    ) {
        if (state.method_11654(WATERLOGGED))
            level.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(level));
        return super.method_9559(state, direction, newState, level, pos, newPos);
    }

    @Nullable
    @Override
    public class_2680 method_9605(class_1750 context) {
        return this.method_9564().method_11657(
            WATERLOGGED,
            context.method_8045().method_8316(context.method_8037()).method_15772()
                == class_3612.field_15910
        );
    }

    @Override
    public class_3610 method_9545(class_2680 state) {
        return state.method_11654(WATERLOGGED) ? class_3612.field_15910.method_15729(false)
                                           : super.method_9545(state);
    }

    @Override
    public void
    method_9565(class_2680 state, class_3218 level, class_2338 pos, class_1799 stack) {
        if (class_1890.method_8225(class_1893.field_9099, stack)
            == 0)
            this.method_9583(level, pos, 5);
    }

    @Nullable
    @Override
    public <T extends class_2586> class_5714 method_32896(class_1937 level, T type) {
        return type instanceof SculkShriekerBlockEntity shrieker ? shrieker.getListener()
                                                                 : null;
    }

    @Nullable
    @Override
    public <T extends class_2586> class_5558<T>
    method_31645(class_1937 level, class_2680 state, class_2591<T> type) {
        return !level.field_9236 ? method_31618(
                   type,
                   WBBlockEntities.SCULK_SHRIEKER.get(),
                   (levelIn, posIn, stateIn, shrieker
                   ) -> shrieker.getListener().tick(levelIn)
               )
                                   : null;
    }
}