package com.cursedcauldron.wildbackport.common.blocks;

import java.util.Collection;
import java.util.Random;
import net.minecraft.class_1936;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3612;
import com.cursedcauldron.wildbackport.common.registry.WBBlocks;
import org.jetbrains.annotations.Nullable;

public interface SculkSpreadable {
    SculkSpreadable DEFAULT = new SculkSpreadable() {
        @Override
        public boolean spread(
            class_1936 level,
            class_2338 pos,
            class_2680 state,
            @Nullable Collection<class_2350> directions,
            boolean postProcess
        ) {
            if (directions == null) {
                return ((SculkVeinBlock) WBBlocks.SCULK_VEIN.get())
                           .getSamePositionOnlyGrower()
                           .grow(level.method_8320(pos), level, pos, postProcess)
                    > 0L;
            } else if (!directions.isEmpty()) {
                return (state.method_26215() || state.method_26227().method_39360(class_3612.field_15910))
                    && SculkVeinBlock.place(level, pos, state, directions);
            } else {
                return SculkSpreadable.super.spread(
                    level, pos, state, directions, postProcess
                );
            }
        }

        @Override
        public int spread(
            SculkSpreadManager.Cursor cursor,
            class_1936 level,
            class_2338 pos,
            Random random,
            SculkSpreadManager spreadManager,
            boolean shouldConvert
        ) {
            return cursor.getDecayDelay() > 0 ? cursor.getCharge() : 0;
        }

        @Override
        public int getDecay(int oldDecay) {
            return Math.max(oldDecay - 1, 0);
        }
    };

    default byte getUpdate() {
        return 1;
    }

    default void spreadAtSamePosition(
        class_1936 level, class_2680 state, class_2338 pos, Random random
    ) {}

    default boolean spread(
        class_1936 level,
        class_2338 pos,
        class_2680 state,
        @Nullable Collection<class_2350> directions,
        boolean postProcess
    ) {
        return ((SculkVeinBlock) WBBlocks.SCULK_VEIN.get())
                   .getAllGrowTypeGrower()
                   .grow(state, level, pos, postProcess)
            > 0L;
    }

    default boolean shouldConvertToSpreadable() {
        return true;
    }

    default int getDecay(int oldDecay) {
        return 1;
    }

    int spread(
        SculkSpreadManager.Cursor cursor,
        class_1936 level,
        class_2338 pos,
        Random random,
        SculkSpreadManager manager,
        boolean shouldConvert
    );
}