package com.cursedcauldron.wildbackport.common.blocks.entity;

import com.cursedcauldron.wildbackport.client.registry.WBCriteriaTriggers;
import com.cursedcauldron.wildbackport.common.blocks.SculkCatalystBlock;
import com.cursedcauldron.wildbackport.common.blocks.SculkSpreadManager;
import com.cursedcauldron.wildbackport.common.entities.access.EntityExperience;
import com.cursedcauldron.wildbackport.common.registry.WBBlockEntities;
import com.cursedcauldron.wildbackport.common.registry.WBGameEvents;
import com.cursedcauldron.wildbackport.common.utils.PositionUtils;
import net.minecraft.class_1282;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2487;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_5707;
import net.minecraft.class_5712;
import net.minecraft.class_5714;
import net.minecraft.class_5716;
import org.jetbrains.annotations.Nullable;

//<>

public class SculkCatalystBlockEntity extends class_2586 implements class_5714 {
    private final class_5707 positionSource
        = new class_5707(this.field_11867);
    private final SculkSpreadManager spreadManager = SculkSpreadManager.create();

    public SculkCatalystBlockEntity(class_2338 pos, class_2680 state) {
        super(WBBlockEntities.SCULK_CATALYST.get(), pos, state);
    }

    @Override
    public class_5716 method_32946() {
        return this.positionSource;
    }

    @Override
    public int method_32948() {
        return 8;
    }

    @Override
    public boolean
    method_32947(class_1937 level, class_5712 event, @Nullable class_1297 entity, class_2338 pos) {
        if (!this.method_11015()) {
            if (event == WBGameEvents.ENTITY_DIE.get()) {
                if (entity instanceof class_1309 living
                    && living instanceof EntityExperience mob) {
                    if (!mob.isExpDropDisabled()) {
                        int charge = mob.getExpToDrop();
                        if (!living.method_6109() && charge > 0) {
                            this.spreadManager.spread(
                                new class_2338(PositionUtils.relative(
                                    PositionUtils.toVec(pos), class_2350.field_11036, 0.5D
                                )),
                                charge
                            );
                            class_1309 attacker = living.method_6065();
                            if (attacker instanceof class_3222 player) {
                                class_1282 source = living.method_6081() == null
                                    ? class_1282.method_5532(player)
                                    : living.method_6081();
                                WBCriteriaTriggers.KILL_MOB_NEAR_SCULK_CATALYST.method_8990(
                                    player, entity, source
                                );
                            }
                        }

                        mob.disableExpDrop();
                        SculkCatalystBlock.bloom(
                            (class_3218) level,
                            this.field_11867,
                            this.method_11010(),
                            level.method_8409()
                        );
                    }

                    return true;
                }
            }
        }

        return false;
    }

    public static void
    tick(class_1937 level, class_2338 pos, class_2680 state, SculkCatalystBlockEntity catalyst) {
        catalyst.spreadManager.tick(level, pos, level.method_8409(), true);
    }

    @Override
    public void method_11014(class_2487 tag) {
        super.method_11014(tag);
        this.spreadManager.readTag(tag);
    }

    @Override
    protected void method_11007(class_2487 tag) {
        super.method_11007(tag);
        this.spreadManager.writeTag(tag);
    }
}