package com.cursedcauldron.wildbackport.common.effects;

import java.util.Optional;
import java.util.function.Supplier;
import net.minecraft.class_1291;
import net.minecraft.class_1293;
import net.minecraft.class_2596;

public interface EffectFactor {
    static EffectFactor of(class_1291 effect) {
        return (EffectFactor) effect;
    }

    class_1291 setFactorCalculationData(Supplier<FactorCalculationData> data);

    Supplier<FactorCalculationData> getFactorCalculationData();

    static Optional<FactorCalculationData> create(class_1291 effect) {
        return Optional.ofNullable(of(effect).getFactorCalculationData().get());
    }

    interface Instance {
        static Instance of(class_1293 instance) {
            return (Instance) instance;
        }

        void setFactorCalculationData(Optional<FactorCalculationData> data);

        Optional<FactorCalculationData> getFactorCalculationData();
    }

    interface Network {
        static Network of(class_2596<?> packet) {
            return (Network) packet;
        }

        FactorCalculationData getFactorCalculationData();
    }
}