package com.cursedcauldron.wildbackport.common.entities;

import java.util.List;
import java.util.Optional;
import java.util.UUID;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1277;
import net.minecraft.class_1282;
import net.minecraft.class_1299;
import net.minecraft.class_1304;
import net.minecraft.class_1308;
import net.minecraft.class_1313;
import net.minecraft.class_1314;
import net.minecraft.class_1331;
import net.minecraft.class_1407;
import net.minecraft.class_1408;
import net.minecraft.class_1542;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1890;
import net.minecraft.class_1928;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3414;
import net.minecraft.class_3419;
import net.minecraft.class_3532;
import net.minecraft.class_4048;
import net.minecraft.class_4050;
import net.minecraft.class_4095;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import net.minecraft.class_4148;
import net.minecraft.class_4149;
import net.minecraft.class_4209;
import net.minecraft.class_4215;
import net.minecraft.class_5132;
import net.minecraft.class_5134;
import net.minecraft.class_6067;
import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.entities.brain.AllayBrain;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.google.common.collect.ImmutableList;
import com.mojang.serialization.Dynamic;
import org.jetbrains.annotations.Nullable;

//<>

public class Allay extends class_1314 implements class_6067 {
    protected static final
        ImmutableList<? extends class_4149<? extends class_4148<? super Allay>>> SENSORS
        = ImmutableList.of(
            class_4149.field_18466,
            class_4149.field_18467,
            class_4149.field_18469,
            class_4149.field_22358
        );
    protected static final ImmutableList<class_4140<?>> MEMORIES = ImmutableList.of(
        class_4140.field_18449,
        class_4140.field_18446,
        class_4140.field_18442,
        class_4140.field_18445,
        class_4140.field_19293,
        class_4140.field_18451,
        class_4140.field_22332,
        WBMemoryModules.LIKED_PLAYER.get(),
        WBMemoryModules.LIKED_NOTEBLOCK.get(),
        WBMemoryModules.LIKED_NOTEBLOCK_COOLDOWN_TICKS.get(),
        WBMemoryModules.ITEM_PICKUP_COOLDOWN_TICKS.get()
    );
    public static final ImmutableList<Float> THROW_SOUND_PITCHES = ImmutableList.of(
        0.5625F,
        0.625F,
        0.75F,
        0.9375F,
        1.0F,
        1.0F,
        1.125F,
        1.25F,
        1.5F,
        1.875F,
        2.0F,
        2.25F,
        2.5F,
        3.0F,
        3.75F,
        4.0F
    );
    private final class_1277 inventory = new class_1277(1);
    private float holdingTicks;
    private float holdingTicksOld;

    public Allay(class_1299<? extends class_1314> type, class_1937 level) {
        super(type, level);
        this.field_6207 = new class_1331(this, 20, true);
        this.method_5952(this.method_5936());
    }

    @Override
    protected class_4095.class_5303<Allay> method_28306() {
        return class_4095.method_28311(MEMORIES, SENSORS);
    }

    @Override
    protected class_4095<?> method_18867(Dynamic<?> dynamic) {
        return AllayBrain.create(this.method_28306().method_28335(dynamic));
    }

    @Override
    @SuppressWarnings("unchecked")
    public class_4095<Allay> method_18868() {
        return (class_4095<Allay>) super.method_18868();
    }

    public static class_5132.class_5133 createAttributes() {
        return class_1308.method_26828()
            .method_26868(class_5134.field_23716, 20.0D)
            .method_26868(class_5134.field_23720, 0.1F)
            .method_26868(class_5134.field_23719, 0.1F)
            .method_26868(class_5134.field_23721, 2.0D)
            .method_26868(class_5134.field_23717, 48.0D);
    }

    @Override
    protected class_1408 method_5965(class_1937 level) {
        class_1407 navigation = new class_1407(this, level);
        navigation.method_6332(false);
        navigation.method_6354(true);
        navigation.method_6331(true);
        return navigation;
    }

    @Override
    public void method_6091(class_243 movementInput) {
        if (this.method_6034() || this.method_5787()) {
            if (this.method_5799()) {
                this.method_5724(0.02F, movementInput);
                this.method_5784(class_1313.field_6308, this.method_18798());
                this.method_18799(this.method_18798().method_1021(0.8F));
            } else if (this.method_5771()) {
                this.method_5724(0.02F, movementInput);
                this.method_5784(class_1313.field_6308, this.method_18798());
                this.method_18799(this.method_18798().method_1021(0.5F));
            } else {
                this.method_5724(this.method_6029(), movementInput);
                this.method_5784(class_1313.field_6308, this.method_18798());
                this.method_18799(this.method_18798().method_1021(0.91F));
            }
        }

        this.method_29242(this, false);
    }

    @Override
    protected float method_18394(class_4050 pose, class_4048 dimensions) {
        return dimensions.field_18068 * 0.6F;
    }

    @Override
    public boolean
    method_5747(float fallDistance, float damageMultiplier, class_1282 source) {
        return false;
    }

    @Override
    public boolean method_5643(class_1282 source, float amount) {
        if (source.method_5529() instanceof class_1657 player) {
            Optional<UUID> likedPlayer
                = this.method_18868().method_18904(WBMemoryModules.LIKED_PLAYER.get());
            if (likedPlayer.isPresent() && player.method_5667().equals(likedPlayer.get()))
                return false;
        }

        return super.method_5643(source, amount);
    }

    @Override
    protected void method_5712(class_2338 pos, class_2680 state) {}

    @Override
    protected void method_5623(
        double fallenDistance, boolean canLand, class_2680 state, class_2338 pos
    ) {}

    @Override
    @Nullable
    protected class_3414 method_5994() {
        return this.method_6084(class_1304.field_6173)
            ? WBSoundEvents.ALLAY_AMBIENT_WITH_ITEM
            : WBSoundEvents.ALLAY_AMBIENT_WITHOUT_ITEM;
    }

    @Override
    @Nullable
    protected class_3414 method_6011(class_1282 source) {
        return WBSoundEvents.ALLAY_HURT;
    }

    @Override
    @Nullable
    protected class_3414 method_6002() {
        return WBSoundEvents.ALLAY_DEATH;
    }

    @Override
    protected float method_6107() {
        return 0.4F;
    }

    @Override
    protected void method_5958() {
        this.field_6002.method_16107().method_15396("allayBrain");
        this.method_18868().method_19542((class_3218) this.field_6002, this);
        this.field_6002.method_16107().method_15407();
        this.field_6002.method_16107().method_15396("allayActivityUpdate");
        AllayBrain.updateActivities(this);
        this.field_6002.method_16107().method_15407();
        this.field_6002.method_16107().method_15396("looting");
        if (!this.field_6002.field_9236 && this.method_5936() && this.method_5805()
            && !this.field_6272
            && this.field_6002.method_8450().method_8355(class_1928.field_19388)) {
            List<class_1542> items = this.field_6002.method_18467(
                class_1542.class, this.method_5829().method_1009(1.0, 1.0, 1.0)
            );
            for (class_1542 item : items) {
                if (item.method_31481() || item.method_6983().method_7960() || item.method_6977()
                    || !this.method_20820(item.method_6983()))
                    continue;
                this.method_5949(item);
            }
        }
        this.field_6002.method_16107().method_15407();
        super.method_5958();
    }

    @Override
    public void method_6007() {
        super.method_6007();
        if (!this.field_6002.field_9236 && this.method_5805() && this.field_6012 % 10 == 0)
            this.method_6025(1.0F);
    }

    @Override
    public void method_5773() {
        super.method_5773();
        if (this.field_6002.field_9236) {
            this.holdingTicksOld = this.holdingTicks;
            if (this.isHoldingItem()) {
                this.holdingTicks = class_3532.method_15363(this.holdingTicks + 1.0F, 0.0F, 5.0F);
            } else {
                this.holdingTicks = class_3532.method_15363(this.holdingTicks - 1.0F, 0.0F, 5.0F);
            }
        }
    }

    @Override
    public boolean method_5936() {
        return !this.isOnItemPickupCooldown() && this.isHoldingItem();
    }

    public boolean isHoldingItem() {
        return !this.method_5998(class_1268.field_5808).method_7960();
    }

    @Override
    public boolean method_18397(class_1799 stack) {
        return false;
    }

    private boolean isOnItemPickupCooldown() {
        return this.method_18868().method_18876(
            WBMemoryModules.ITEM_PICKUP_COOLDOWN_TICKS.get(), class_4141.field_18456
        );
    }

    @Override
    protected class_1269 method_5992(class_1657 player, class_1268 hand) {
        class_1799 playerStack = player.method_5998(hand);
        class_1799 allayStack = this.method_5998(class_1268.field_5808);
        if (allayStack.method_7960() && !playerStack.method_7960()) {
            class_1799 stack = playerStack.method_7972();
            stack.method_7939(1);
            this.method_6122(class_1268.field_5808, stack);
            if (!player.method_31549().field_7477)
                playerStack.method_7934(1);
            this.field_6002.method_8449(
                player,
                this,
                WBSoundEvents.ALLAY_ITEM_GIVEN,
                class_3419.field_15254,
                2.0F,
                1.0F
            );
            this.method_18868().method_18878(
                WBMemoryModules.LIKED_PLAYER.get(), player.method_5667()
            );
            return class_1269.field_5812;
        } else if (!allayStack.method_7960() && hand == class_1268.field_5808 && playerStack.method_7960()) {
            this.method_5673(class_1304.field_6173, class_1799.field_8037);
            this.field_6002.method_8449(
                player,
                this,
                WBSoundEvents.ALLAY_ITEM_TAKEN,
                class_3419.field_15254,
                2.0F,
                1.0F
            );
            this.method_6104(class_1268.field_5808);
            for (class_1799 stack : this.method_35199().method_24514())
                class_4215.method_19949(this, stack, this.method_19538());
            this.method_18868().method_18875(WBMemoryModules.LIKED_PLAYER.get());
            player.method_7270(allayStack);
            return class_1269.field_5812;
        } else {
            return super.method_5992(player, hand);
        }
    }

    @Override
    public class_1277 method_35199() {
        return this.inventory;
    }

    @Override
    public boolean method_20820(class_1799 stack) {
        class_1799 heldItem = this.method_5998(class_1268.field_5808);
        return !heldItem.method_7960() && heldItem.method_7929(stack)
            && this.inventory.method_27070(stack);
    }

    @Override
    protected void method_5949(class_1542 itemEntity) {
        class_1799 stack = itemEntity.method_6983();
        if (this.method_20820(stack)) {
            class_1277 inventory = this.method_35199();
            boolean canAdd = inventory.method_27070(stack);
            if (!canAdd)
                return;

            this.method_29499(itemEntity);
            this.method_6103(itemEntity, stack.method_7947());
            class_1799 addedStack = inventory.method_5491(stack);
            if (addedStack.method_7960()) {
                itemEntity.method_31472();
            } else {
                stack.method_7939(addedStack.method_7947());
            }
        }
    }

    @Override
    protected void method_18409() {
        super.method_18409();
        class_4209.method_19774(this);
    }

    @Override
    protected boolean method_5776() {
        return !this.method_24828();
    }

    public float getHoldingItemAnimationProgress(float animationProgress) {
        return class_3532.method_16439(animationProgress, this.holdingTicksOld, this.holdingTicks)
            / 5.0F;
    }

    @Override
    protected void method_16078() {
        super.method_16078();
        this.inventory.method_24514().forEach(this::method_5775);
        class_1799 stack = this.method_6118(class_1304.field_6173);
        if (!stack.method_7960() && !class_1890.method_8221(stack)) {
            this.method_5775(stack);
            this.method_5673(class_1304.field_6173, class_1799.field_8037);
        }
    }

    @Override
    public boolean method_5974(double distance) {
        return false;
    }

    @Override
    public void method_5652(class_2487 tag) {
        super.method_5652(tag);
        tag.method_10566("Inventory", this.inventory.method_7660());
    }

    @Override
    public void method_5749(class_2487 tag) {
        super.method_5749(tag);
        this.inventory.method_7659(tag.method_10554("Inventory", 10));
    }

    public Iterable<class_2338> getPotentialEscapePositions() {
        class_238 box = this.method_5829();
        int minX = class_3532.method_15357(box.field_1323 - 0.5D);
        int maxX = class_3532.method_15357(box.field_1320 + 0.5D);
        int minY = class_3532.method_15357(box.field_1322 - 0.5D);
        int maxY = class_3532.method_15357(box.field_1325 + 0.5D);
        int minZ = class_3532.method_15357(box.field_1321 - 0.5D);
        int maxZ = class_3532.method_15357(box.field_1324 + 0.5D);
        return class_2338.method_10094(minX, minY, minZ, maxX, maxY, maxZ);
    }

    @Override
    public class_243 method_29919() {
        return new class_243(0.0D, this.method_5751() * 0.6D, this.method_17681() * 0.1D);
    }
}