package com.cursedcauldron.wildbackport.common.entities;

import com.cursedcauldron.wildbackport.common.registry.WBItems;
import com.cursedcauldron.wildbackport.common.registry.entity.WBEntityTypes;
import net.minecraft.class_1262;
import net.minecraft.class_1263;
import net.minecraft.class_1264;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1282;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1690;
import net.minecraft.class_1703;
import net.minecraft.class_1707;
import net.minecraft.class_173;
import net.minecraft.class_174;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_181;
import net.minecraft.class_1928;
import net.minecraft.class_1937;
import net.minecraft.class_2371;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_3908;
import net.minecraft.class_47;
import net.minecraft.class_4838;
import net.minecraft.class_52;
import net.minecraft.class_5630;
import net.minecraft.class_5712;
import net.minecraft.server.MinecraftServer;
import org.jetbrains.annotations.Nullable;

//<>

public class ChestBoat extends MangroveBoat implements class_1263, class_3908 {
    private class_2371<class_1799> stacks = class_2371.method_10213(27, class_1799.field_8037);
    @Nullable
    private class_2960 lootTable;
    private long lootTableSeed;

    public ChestBoat(class_1299<? extends class_1690> type, class_1937 level) {
        super(type, level);
    }

    public ChestBoat(class_1937 level, double x, double y, double z) {
        super(WBEntityTypes.CHEST_BOAT.get(), level);
        this.method_5814(x, y, z);
        this.field_6014 = x;
        this.field_6036 = y;
        this.field_5969 = z;
    }

    @Override
    public double method_5621() {
        return 0.15F;
    }

    @Override
    protected boolean method_5818(class_1297 entity) {
        return this.method_5685().size() < 1;
    }

    @Override
    protected void method_5652(class_2487 tag) {
        super.method_5652(tag);
        if (this.lootTable != null) {
            tag.method_10582("LootTable", this.lootTable.toString());
            if (this.lootTableSeed != 0L)
                tag.method_10544("LootTableSeed", this.lootTableSeed);
        } else {
            class_1262.method_5426(tag, this.stacks);
        }
    }

    @Override
    protected void method_5749(class_2487 tag) {
        super.method_5749(tag);
        this.stacks = class_2371.method_10213(this.method_5439(), class_1799.field_8037);
        if (tag.method_10573("LootTable", 8)) {
            this.lootTable = new class_2960(tag.method_10558("LootTable"));
            this.lootTableSeed = tag.method_10537("LootTableSeed");
        } else {
            class_1262.method_5429(tag, this.stacks);
        }
    }

    @Override
    protected void dropItems(class_1282 source) {
        super.dropItems(source);
        if (this.field_6002.method_8450().method_8355(class_1928.field_19393)) {
            class_1264.method_5452(this.field_6002, this, this);
            if (!this.field_6002.field_9236) {
                class_1297 entity = source.method_5526();
                if (entity != null && entity.method_5864() == class_1299.field_6097)
                    class_4838.method_24733((class_1657) entity, true);
            }
        }
    }

    @Override
    public void method_5650(class_1297.class_5529 reason) {
        if (!this.field_6002.field_9236 && reason.method_31486())
            class_1264.method_5452(this.field_6002, this, this);
        super.method_5650(reason);
    }

    @Override
    public class_1269 method_5688(class_1657 player, class_1268 hand) {
        if (player.method_18276()) {
            player.method_17355(this);
            if (!player.field_6002.field_9236) {
                this.method_32875(class_5712.field_28176, player);
                class_4838.method_24733(player, true);
                return class_1269.field_21466;
            } else {
                return class_1269.field_5812;
            }
        }

        return super.method_5688(player, hand);
    }

    public void openInventory(class_1657 player) {
        player.method_17355(this);
        if (!player.field_6002.method_8608()) {
            this.method_32875(class_5712.field_28176, player);
            class_4838.method_24733(player, true);
        }
    }

    @Override
    @SuppressWarnings("UnnecessaryDefault")
    public class_1792 method_7557() {
        return switch (this.getBoatType()) {
            case OAK -> WBItems.OAK_CHEST_BOAT.get();
            case SPRUCE -> WBItems.SPRUCE_CHEST_BOAT.get();
            case BIRCH -> WBItems.BIRCH_CHEST_BOAT.get();
            case JUNGLE -> WBItems.JUNGLE_CHEST_BOAT.get();
            case ACACIA -> WBItems.ACACIA_CHEST_BOAT.get();
            case DARK_OAK -> WBItems.DARK_OAK_CHEST_BOAT.get();
            default -> WBItems.MANGROVE_CHEST_BOAT.get();
        };
    }

    public void unpackLootTable(@Nullable class_1657 player) {
        MinecraftServer server = this.field_6002.method_8503();
        if (this.lootTable != null && server != null) {
            class_52 lootTable = server.method_3857().method_367(this.lootTable);
            if (player != null) class_174.field_24479.method_27993((class_3222)player, this.lootTable);

            this.lootTable = null;
            class_47.class_48 builder = new class_47.class_48((class_3218)this.field_6002).method_312(class_181.field_24424, this.method_19538()).method_304(this.lootTableSeed);
            if (player != null) builder.method_303(player.method_7292()).method_312(class_181.field_1226, player);

            lootTable.method_329(this, builder.method_309(class_173.field_1179));
        }
    }

    @Override
    public void method_5448() {
        this.unpackLootTable(null);
        this.stacks.clear();
    }

    @Override
    public int method_5439() {
        return 27;
    }

    @Override
    public class_1799 method_5438(int slot) {
        this.unpackLootTable(null);
        return this.stacks.get(slot);
    }

    @Override
    public class_1799 method_5434(int slot, int amount) {
        this.unpackLootTable(null);
        return class_1262.method_5430(this.stacks, slot, amount);
    }

    @Override
    public class_1799 method_5441(int slot) {
        this.unpackLootTable(null);
        class_1799 stack = this.stacks.get(slot);
        if (stack.method_7960()) {
            return class_1799.field_8037;
        } else {
            this.stacks.set(slot, class_1799.field_8037);
            return stack;
        }
    }

    @Override
    public void method_5447(int slot, class_1799 stack) {
        this.unpackLootTable(null);
        this.stacks.set(slot, stack);
        if (!stack.method_7960() && stack.method_7947() > this.method_5444()) stack.method_7939(this.method_5444());
    }

    @Override
    public class_5630 method_32318(int slot) {
        return slot >= 0 && slot < this.method_5439() ? new class_5630() {
            @Override public class_1799 method_32327() {
                return ChestBoat.this.method_5438(slot);
            }

            @Override public boolean method_32332(class_1799 stack) {
                ChestBoat.this.method_5447(slot, stack);
                return true;
            }
        } :
                super.method_32318(slot);
        }

        @Override
        public void method_5431() {}

        @Override
        public boolean method_5443(class_1657 player) {
            return !this.method_31481()
                && this.method_19538().method_24802(player.method_19538(), 8.0D);
        }

        @Override
        public boolean method_5442() {
            for (class_1799 stack : this.stacks)
                if (!stack.method_7960())
                    return false;
            return true;
        }

        @Override
        @Nullable
        public class_1703 createMenu(
            int i, class_1661 inventory, class_1657 player
        ) {
            if (this.lootTable == null || !player.method_7325()) {
                this.unpackLootTable(inventory.field_7546);
                return class_1707.method_19245(i, inventory, this);
            }

            return null;
        }
    }