package com.cursedcauldron.wildbackport.common.entities.brain;

import java.util.Optional;
import java.util.UUID;
import net.minecraft.class_1309;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_4095;
import net.minecraft.class_4099;
import net.minecraft.class_4101;
import net.minecraft.class_4102;
import net.minecraft.class_4110;
import net.minecraft.class_4112;
import net.minecraft.class_4115;
import net.minecraft.class_4118;
import net.minecraft.class_4119;
import net.minecraft.class_4120;
import net.minecraft.class_4125;
import net.minecraft.class_4168;
import net.minecraft.class_4208;
import net.minecraft.class_4815;
import net.minecraft.class_4821;
import net.minecraft.class_5753;
import net.minecraft.class_6019;
import net.minecraft.class_6028;
import com.cursedcauldron.wildbackport.common.entities.Allay;
import com.cursedcauldron.wildbackport.common.entities.brain.allay.FlyingRandomStroll;
import com.cursedcauldron.wildbackport.common.entities.brain.allay.GiveInventoryToLookTarget;
import com.cursedcauldron.wildbackport.common.entities.brain.allay.StayCloseToTarget;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.ImmutableSet;
import com.mojang.datafixers.util.Pair;

//<>

public class AllayBrain {
    public static class_4095<?> create(class_4095<Allay> brain) {
        addCoreActivities(brain);
        addIdleActivities(brain);
        brain.method_18890(ImmutableSet.of(class_4168.field_18594));
        brain.method_18897(class_4168.field_18595);
        brain.method_24536();
        return brain;
    }

    private static void addCoreActivities(class_4095<Allay> brain) {
        brain.method_18882(
            class_4168.field_18594,
            0,
            ImmutableList.of(
                new class_4125(0.8F),
                new class_6028(2.5F),
                new class_4110(45, 90),
                new class_4112(),
                new class_5753(
                    WBMemoryModules.LIKED_NOTEBLOCK_COOLDOWN_TICKS.get()
                ),
                new class_5753(WBMemoryModules.ITEM_PICKUP_COOLDOWN_TICKS.get(
                ))
            )
        );
    }

    private static void addIdleActivities(class_4095<Allay> brain) {
        brain.method_24529(
            class_4168.field_18595,
            ImmutableList.of(
                Pair.of(
                    0, new class_4815<>(entity -> { return true; }, 1.75F, true, 32)
                ),
                Pair.of(
                    1, new GiveInventoryToLookTarget<>(AllayBrain::getLookTarget, 2.25F)
                ),
                Pair.of(
                    2, new StayCloseToTarget<>(AllayBrain::getLookTarget, 4, 16, 2.25F)
                ),
                Pair.of(
                    3,
                    new class_4821<>(
                        new class_4119(entity -> { return true; }, 6.0F),
                        class_6019.method_35017(30, 60)
                    )
                ),
                Pair.of(
                    4,
                    new class_4118<>(ImmutableList.of(
                        Pair.of(new FlyingRandomStroll(1.0F), 2),
                        Pair.of(new class_4120(1.0F, 3), 2),
                        Pair.of(new class_4101(30, 60), 1)
                    ))
                )
            ),
            ImmutableSet.of()
        );
    }

    public static void updateActivities(Allay allay) {
        allay.method_18868().method_24531(ImmutableList.of(class_4168.field_18595));
    }

    public static void rememberNoteBlock(class_1309 entity, class_2338 pos) {
        class_4095<?> brain = entity.method_18868();
        class_4208 globalPos = class_4208.method_19443(entity.method_37908().method_27983(), pos);
        Optional<class_4208> noteblock
            = brain.method_18904(WBMemoryModules.LIKED_NOTEBLOCK.get());
        if (noteblock.isEmpty()) {
            brain.method_18878(WBMemoryModules.LIKED_NOTEBLOCK.get(), globalPos);
            brain.method_18878(WBMemoryModules.LIKED_NOTEBLOCK_COOLDOWN_TICKS.get(), 600);
        } else if (noteblock.get().equals(globalPos)) {
            brain.method_18878(WBMemoryModules.LIKED_NOTEBLOCK_COOLDOWN_TICKS.get(), 600);
        }
    }

    private static Optional<class_4115> getLookTarget(class_1309 entity) {
        class_4095<?> brain = entity.method_18868();
        Optional<class_4208> likedNoteBlock
            = brain.method_18904(WBMemoryModules.LIKED_NOTEBLOCK.get());
        if (likedNoteBlock.isPresent()) {
            class_4208 pos = likedNoteBlock.get();
            if (shouldGoTowardsNoteBlock(entity, brain, pos))
                return Optional.of(new class_4099(pos.method_19446().method_10084()));
            brain.method_18875(WBMemoryModules.LIKED_NOTEBLOCK.get());
        }

        return getLikedLookTarget(entity);
    }

    private static boolean
    shouldGoTowardsNoteBlock(class_1309 entity, class_4095<?> brain, class_4208 pos) {
        Optional<Integer> cooldownTicks
            = brain.method_18904(WBMemoryModules.LIKED_NOTEBLOCK_COOLDOWN_TICKS.get());
        class_1937 level = entity.method_37908();
        return level.method_27983() == pos.method_19442()
            && level.method_8320(pos.method_19446()).method_27852(class_2246.field_10179)
            && cooldownTicks.isPresent();
    }

    private static Optional<class_4115> getLikedLookTarget(class_1309 entity) {
        return getLikedPlayer(entity).map(player -> new class_4102(player, true));
    }

    public static Optional<class_3222> getLikedPlayer(class_1309 entity) {
        class_1937 level = entity.method_37908();
        if (!level.field_9236 && level instanceof class_3218 server) {
            Optional<UUID> likedPlayer
                = entity.method_18868().method_18904(WBMemoryModules.LIKED_PLAYER.get());
            if (likedPlayer.isPresent()) {
                if (server.method_14190(likedPlayer.get()) instanceof class_3222 player) {
                    if ((player.field_13974.method_14267() || player.field_13974.method_14268())
                        && player.method_24516(entity, 64.0D))
                        return Optional.of(player);
                }

                return Optional.empty();
            }
        }

        return Optional.empty();
    }
}