package com.cursedcauldron.wildbackport.common.entities.brain.allay;

import java.util.Optional;
import java.util.function.Function;
import net.minecraft.class_1309;
import net.minecraft.class_156;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_3419;
import net.minecraft.class_4097;
import net.minecraft.class_4115;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import net.minecraft.class_6067;
import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.entities.Allay;
import com.cursedcauldron.wildbackport.common.entities.brain.AllayBrain;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.cursedcauldron.wildbackport.common.utils.MobUtils;
import com.google.common.collect.ImmutableMap;

//<>

public class GiveInventoryToLookTarget<E extends class_1309 & class_6067>
    extends class_4097<E> {
    private final Function<class_1309, Optional<class_4115>> lookTarget;
    private final float speed;

    public GiveInventoryToLookTarget(
        Function<class_1309, Optional<class_4115>> lookTarget, float speed
    ) {
        super(ImmutableMap.of(
            class_4140.field_18446,
            class_4141.field_18458,
            class_4140.field_18445,
            class_4141.field_18458,
            WBMemoryModules.ITEM_PICKUP_COOLDOWN_TICKS.get(),
            class_4141.field_18458
        ));
        this.lookTarget = lookTarget;
        this.speed = speed;
    }

    @Override
    protected boolean method_18919(class_3218 level, E entity) {
        return this.hasItemAndTarget(entity);
    }

    @Override
    protected boolean method_18927(class_3218 level, E entity, long time) {
        return this.hasItemAndTarget(entity);
    }

    @Override
    protected void method_18920(class_3218 level, E entity, long time) {
        this.lookTarget.apply(entity).ifPresent(
            target -> MobUtils.walkTowards(entity, target, this.speed, 3)
        );
    }

    @Override
    protected void method_18924(class_3218 level, E entity, long time) {
        Optional<class_4115> lookTarget = this.lookTarget.apply(entity);
        if (lookTarget.isPresent()) {
            class_4115 target = lookTarget.get();
            double distance
                = target.method_18991().method_1022(entity.method_33571());
            if (distance < 3.0D) {
                class_1799 stack = entity.method_35199().method_5434(0, 1);
                if (!stack.method_7960()) {
                    playThrowSound(entity, stack, offsetTarget(target));
                    if (entity instanceof Allay allay) {
                        AllayBrain.getLikedPlayer(allay).ifPresent(
                            player -> this.triggerCriteria(target, stack, player)
                        );
                    }

                    entity.method_18868().method_18878(
                        WBMemoryModules.ITEM_PICKUP_COOLDOWN_TICKS.get(), 60
                    );
                }
            }
        }
    }

    private void
    triggerCriteria(class_4115 target, class_1799 stack, class_3222 player) {
        class_2338 pos = target.method_18989().method_10074();
        //        WBCriteriaTriggers.ALLAY_DROP_ITEM_ON_BLOCK.trigger(player, pos, stack);
    }

    private boolean hasItemAndTarget(E entity) {
        return !entity.method_35199().method_5442()
            && this.lookTarget.apply(entity).isPresent();
    }

    private static class_243 offsetTarget(class_4115 tracker) {
        return tracker.method_18991().method_1031(0.0D, 1.0D, 0.0D);
    }

    public static void playThrowSound(class_1309 entity, class_1799 stack, class_243 pos) {
        class_243 velocity = new class_243(0.2F, 0.3F, 0.2F);
        MobUtils.give(entity, stack, pos, velocity, 0.2F);
        class_1937 level = entity.field_6002;
        if (level.method_8510() % 7L == 0L && level.field_9229.nextDouble() < 0.9D) {
            float pitch = class_156.method_32309(Allay.THROW_SOUND_PITCHES, level.method_8409());
            level.method_8449(
                null,
                entity,
                WBSoundEvents.ALLAY_ITEM_THROW,
                class_3419.field_15254,
                1.0F,
                pitch
            );
        }
    }
}