package com.cursedcauldron.wildbackport.common.entities.brain.allay;

import java.util.Optional;
import java.util.function.Function;
import net.minecraft.class_1309;
import net.minecraft.class_3218;
import net.minecraft.class_4097;
import net.minecraft.class_4115;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import com.cursedcauldron.wildbackport.common.utils.MobUtils;
import com.google.common.collect.ImmutableMap;

public class StayCloseToTarget<E extends class_1309> extends class_4097<E> {
    private final Function<class_1309, Optional<class_4115>> lookTarget;
    private final int completitionRange;
    private final int searchRange;
    private final float speed;

    public StayCloseToTarget(
        Function<class_1309, Optional<class_4115>> lookTarget,
        int completitionRange,
        int searchRange,
        float speed
    ) {
        super(ImmutableMap.of(class_4140.field_18445, class_4141.field_18457));
        this.lookTarget = lookTarget;
        this.completitionRange = completitionRange;
        this.searchRange = searchRange;
        this.speed = speed;
    }

    @Override
    protected boolean method_18919(class_3218 level, E entity) {
        Optional<class_4115> tracker = this.lookTarget.apply(entity);
        return tracker.isPresent()
            && !entity.method_19538().method_24802(
                tracker.get().method_18991(), this.searchRange
            );
    }

    @Override
    protected void method_18920(class_3218 level, E entity, long time) {
        MobUtils.walkTowards(
            entity,
            this.lookTarget.apply(entity).get(),
            this.speed,
            this.completitionRange
        );
    }
}