package com.cursedcauldron.wildbackport.common.entities.brain.frog;

import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.entities.Frog;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.google.common.collect.ImmutableMap;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_3218;
import net.minecraft.class_3419;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;

public class LayFrogSpawn extends class_4097<Frog> {
    private final class_2248 frogSpawn;
    private final class_4140<?> triggerMemory;

    public LayFrogSpawn(class_2248 block, class_4140<?> triggerMemory) {
        super(ImmutableMap.of(
            class_4140.field_22355,
            class_4141.field_18457,
            class_4140.field_18445,
            class_4141.field_18456,
            WBMemoryModules.IS_PREGNANT.get(),
            class_4141.field_18456
        ));
        this.frogSpawn = block;
        this.triggerMemory = triggerMemory;
    }

    @Override
    protected boolean checkExtraStartConditions(class_3218 level, Frog frog) {
        return !frog.method_5816() && frog.method_24828();
    }

    @Override
    protected void start(class_3218 level, Frog frog, long time) {
        class_2338 blockPos = frog.method_24515().method_10074();
        for (class_2350 direction : class_2350.class_2353.field_11062) {
            class_2338 offset = blockPos.method_10093(direction);
            class_2338 above = offset.method_10084();
            if (level.method_8320(offset).method_27852(class_2246.field_10382)
                && level.method_8320(above).method_26215()) {
                level.method_8652(above, this.frogSpawn.method_9564(), 3);
                level.method_8449(
                    null,
                    frog,
                    WBSoundEvents.FROG_LAY_SPAWN,
                    class_3419.field_15245,
                    1.0F,
                    1.0F
                );
                frog.method_18868().method_18875(this.triggerMemory);
                return;
            }
        }
    }
}