package com.cursedcauldron.wildbackport.common.entities.brain.frog;

import com.google.common.collect.ImmutableMap;
import net.minecraft.class_1314;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3486;
import net.minecraft.class_3726;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import net.minecraft.class_4215;

public class WalkTowardsLand extends class_4097<class_1314> {
    private final int distance;
    private final float speedModifier;
    private long nextStartTime;

    public WalkTowardsLand(int distance, float speedModifier) {
        super(ImmutableMap.of(
            class_4140.field_22355,
            class_4141.field_18457,
            class_4140.field_18445,
            class_4141.field_18457,
            class_4140.field_18446,
            class_4141.field_18458
        ));
        this.distance = distance;
        this.speedModifier = speedModifier;
    }

    @Override
    protected void stop(class_3218 level, class_1314 entity, long time) {
        this.nextStartTime = time + 60L;
    }

    @Override
    protected boolean checkExtraStartConditions(class_3218 level, class_1314 entity) {
        return entity.field_6002.method_8316(entity.method_24515()).method_15767(class_3486.field_15517);
    }

    @Override
    protected void start(class_3218 level, class_1314 entity, long time) {
        if (time >= this.nextStartTime) {
            class_2338 pos = entity.method_24515();
            class_2338.class_2339 mutable = new class_2338.class_2339();
            class_3726 context = class_3726.method_16195(entity);

            for (class_2338 position : class_2338.method_25996(
                     pos, this.distance, this.distance, this.distance
                 )) {
                if (position.method_10263() != pos.method_10263() || position.method_10260() != pos.method_10260()) {
                    class_2680 state = level.method_8320(position);
                    class_2680 landState = level.method_8320(
                        mutable.method_25505(position, class_2350.field_11033)
                    );
                    if (!state.method_27852(class_2246.field_10382) && level.method_8316(position).method_15769()
                        && state.method_26194(level, position, context).method_1110()
                        && landState.method_26206(level, mutable, class_2350.field_11036)) {
                        this.nextStartTime = time + 60L;
                        class_4215.method_24561(
                            entity, position.method_10062(), this.speedModifier, 1
                        );
                        return;
                    }
                }
            }
        }
    }
}