package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.cursedcauldron.wildbackport.common.entities.access.api.Poses;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.google.common.collect.ImmutableMap;
import net.minecraft.class_3218;
import net.minecraft.class_4050;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;

//<>

public class Emerging<E extends Warden> extends class_4097<E> {
    public Emerging(int duration) {
        super(
            ImmutableMap.of(
                WBMemoryModules.IS_EMERGING.get(),
                class_4141.field_18456,
                class_4140.field_18445,
                class_4141.field_18457,
                class_4140.field_18446,
                class_4141.field_18458
            ),
            duration
        );
    }

    @Override
    protected boolean canStillUse(class_3218 level, E entity, long time) {
        return true;
    }

    @Override
    protected void start(class_3218 level, E entity, long time) {
        entity.method_18380(Poses.EMERGING.get());
        entity.method_5783(WBSoundEvents.WARDEN_EMERGE, 5.0F, 1.0F);
    }

    @Override
    protected void stop(class_3218 level, E entity, long time) {
        if (entity.hasPose(Poses.EMERGING.get())) {
            entity.method_18380(class_4050.field_18076);
        }
    }
}