package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import java.util.Optional;
import java.util.function.Function;
import net.minecraft.class_1309;
import net.minecraft.class_3218;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.google.common.collect.ImmutableMap;

public class FindRoarTarget<E extends Warden> extends class_4097<E> {
    private final Function<E, Optional<? extends class_1309>> targetFinder;

    public FindRoarTarget(Function<E, Optional<? extends class_1309>> targetFinder) {
        super(ImmutableMap.of(
            WBMemoryModules.ROAR_TARGET.get(),
            class_4141.field_18457,
            class_4140.field_22355,
            class_4141.field_18457,
            class_4140.field_19293,
            class_4141.field_18458
        ));
        this.targetFinder = targetFinder;
    }

    @Override
    protected boolean checkExtraStartConditions(class_3218 level, E warden) {
        return this.targetFinder.apply(warden).filter(warden::isValidTarget).isPresent();
    }

    @Override
    protected void start(class_3218 level, E warden, long time) {
        this.targetFinder.apply(warden).ifPresent(target -> {
            warden.method_18868().method_18878(WBMemoryModules.ROAR_TARGET.get(), target);
            warden.method_18868().method_18875(class_4140.field_19293);
        });
    }
}