package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import java.util.Random;
import net.minecraft.class_1308;
import net.minecraft.class_2338;
import net.minecraft.class_3218;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import net.minecraft.class_4215;
import com.google.common.collect.ImmutableMap;

public class GoToTargetLocation<E extends class_1308> extends class_4097<E> {
    private final class_4140<class_2338> locationMemory;
    private final int closeEnoughDistance;
    private final float speedModifier;

    public GoToTargetLocation(
        class_4140<class_2338> locationMemory,
        int closeEnoughDistance,
        float speedModifier
    ) {
        super(ImmutableMap.of(
            locationMemory,
            class_4141.field_18456,
            class_4140.field_22355,
            class_4141.field_18457,
            class_4140.field_18445,
            class_4141.field_18457,
            class_4140.field_18446,
            class_4141.field_18458
        ));
        this.locationMemory = locationMemory;
        this.closeEnoughDistance = closeEnoughDistance;
        this.speedModifier = speedModifier;
    }

    @Override
    protected void start(class_3218 level, E entity, long time) {
        class_2338 pos = this.getTargetLocation(entity);
        boolean inRange
            = pos.method_19771(entity.method_24515(), this.closeEnoughDistance);
        if (!inRange)
            class_4215.method_24561(
                entity,
                getNearbyPos(entity, pos),
                this.speedModifier,
                this.closeEnoughDistance
            );
    }

    private static class_2338 getNearbyPos(class_1308 mob, class_2338 pos) {
        Random random = mob.field_6002.method_8409();
        return pos.method_10069(getRandomOffset(random), 0, getRandomOffset(random));
    }

    private static int getRandomOffset(Random random) {
        return random.nextInt(3) - 1;
    }

    private class_2338 getTargetLocation(class_1308 mob) {
        return mob.method_18868().method_18904(this.locationMemory).get();
    }
}