package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.cursedcauldron.wildbackport.common.entities.access.api.Poses;
import com.cursedcauldron.wildbackport.common.entities.brain.WardenBrain;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.google.common.collect.ImmutableMap;
import net.minecraft.class_1309;
import net.minecraft.class_3218;
import net.minecraft.class_3902;
import net.minecraft.class_4050;
import net.minecraft.class_4095;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import net.minecraft.class_4215;

public class Roar extends class_4097<Warden> {
    public Roar() {
        super(
            ImmutableMap.of(
                WBMemoryModules.ROAR_TARGET.get(),
                class_4141.field_18456,
                class_4140.field_22355,
                class_4141.field_18457,
                WBMemoryModules.ROAR_SOUND_COOLDOWN.get(),
                class_4141.field_18458,
                WBMemoryModules.ROAR_SOUND_DELAY.get(),
                class_4141.field_18458
            ),
            WardenBrain.ROAR_DURATION
        );
    }

    @Override
    protected void start(class_3218 level, Warden warden, long time) {
        class_4095<?> brain = warden.method_18868();
        brain.method_24525(
            WBMemoryModules.ROAR_SOUND_DELAY.get(), class_3902.field_17274, 26L
        );
        brain.method_18875(class_4140.field_18445);
        class_1309 target
            = warden.method_18868().method_18904(WBMemoryModules.ROAR_TARGET.get()).get();
        class_4215.method_19554(warden, target);
        warden.method_18380(Poses.ROARING.get());
        warden.increaseAngerAt(target, 20, false);
    }

    @Override
    protected boolean canStillUse(class_3218 level, Warden warden, long time) {
        return true;
    }

    @Override
    protected void tick(class_3218 level, Warden warden, long time) {
        if (!warden.method_18868().method_18896(WBMemoryModules.ROAR_SOUND_DELAY.get())
            && !warden.method_18868().method_18896(WBMemoryModules.ROAR_SOUND_COOLDOWN.get()
            )) {
            warden.method_18868().method_24525(
                WBMemoryModules.ROAR_SOUND_COOLDOWN.get(),
                class_3902.field_17274,
                WardenBrain.ROAR_DURATION - 25
            );
            warden.method_5783(WBSoundEvents.WARDEN_ROAR, 3.0F, 1.0F);
        }
    }

    @Override
    protected void stop(class_3218 level, Warden warden, long time) {
        if (warden.hasPose(Poses.ROARING.get()))
            warden.method_18380(class_4050.field_18076);
        warden.method_18868()
            .method_18904(WBMemoryModules.ROAR_TARGET.get())
            .ifPresent(warden::updateAttackTarget);
        warden.method_18868().method_18875(WBMemoryModules.ROAR_TARGET.get());
    }
}