package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import com.cursedcauldron.wildbackport.client.registry.WBParticleTypes;
import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.cursedcauldron.wildbackport.core.mixin.access.DamageSourceAccessor;
import com.google.common.collect.ImmutableMap;
import net.minecraft.class_1282;
import net.minecraft.class_1285;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_243;
import net.minecraft.class_3218;
import net.minecraft.class_3532;
import net.minecraft.class_3902;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import net.minecraft.class_5134;

//<>

public class SonicBoom extends class_4097<Warden> {
    private static final int SOUND_DELAY = class_3532.method_15384(34.0D);
    private static final int DURATION = class_3532.method_15386(60.0F);

    public SonicBoom() {
        super(
            ImmutableMap.of(
                class_4140.field_22355,
                class_4141.field_18456,
                WBMemoryModules.SONIC_BOOM_COOLDOWN.get(),
                class_4141.field_18457,
                WBMemoryModules.SONIC_BOOM_SOUND_COOLDOWN.get(),
                class_4141.field_18458,
                WBMemoryModules.SONIC_BOOM_SOUND_DELAY.get(),
                class_4141.field_18458
            ),
            DURATION
        );
    }

    @Override
    protected boolean checkExtraStartConditions(class_3218 level, Warden warden) {
        return warden.closerThan(
            warden.method_18868().method_18904(class_4140.field_22355).get(),
            15.0D,
            20.0D
        );
    }

    @Override
    protected boolean canStillUse(class_3218 level, Warden warden, long time) {
        return true;
    }

    @Override
    protected void start(class_3218 level, Warden warden, long time) {
        warden.method_18868().method_24525(
            class_4140.field_22475, true, DURATION
        );
        warden.method_18868().method_24525(
            WBMemoryModules.SONIC_BOOM_SOUND_DELAY.get(), class_3902.field_17274, SOUND_DELAY + 5
        );
        level.method_8421(warden, Warden.SONIC_BOOM);
        warden.method_5783(WBSoundEvents.WARDEN_SONIC_CHARGE, 3.0F, 1.0F);
    }

    @Override
    protected void tick(class_3218 level, Warden warden, long time) {
        warden.method_18868()
            .method_18904(class_4140.field_22355)
            .ifPresent(target -> warden.method_5988().method_19615(target.method_19538()));
        if (!warden.method_18868().method_18896(WBMemoryModules.SONIC_BOOM_SOUND_DELAY.get()
            )
            && !warden.method_18868().method_18896(
                WBMemoryModules.SONIC_BOOM_SOUND_COOLDOWN.get()
            )) {
            warden.method_18868().method_24525(
                WBMemoryModules.SONIC_BOOM_SOUND_COOLDOWN.get(),
                class_3902.field_17274,
                DURATION - SOUND_DELAY + 5
            );
            warden.method_18868()
                .method_18904(class_4140.field_22355)
                .filter(warden::isValidTarget)
                .filter(target -> warden.closerThan(target, 15.0D, 20.0D))
                .ifPresent(target -> {
                    class_243 sourcePos = warden.method_19538().method_1031(0.0D, 1.6F, 0.0D);
                    class_243 targetPos = target.method_33571().method_1020(sourcePos);
                    class_243 distance = targetPos.method_1029();

                    for (int i = 1; i < class_3532.method_15357(targetPos.method_1033()) + 7; ++i) {
                        class_243 charge = sourcePos.method_1019(distance.method_1021(i));
                        level.method_14199(
                            WBParticleTypes.SONIC_BOOM.get(),
                            charge.field_1352,
                            charge.field_1351,
                            charge.field_1350,
                            1,
                            0.0D,
                            0.0D,
                            0.0D,
                            0.0D
                        );
                    }

                    warden.method_5783(WBSoundEvents.WARDEN_SONIC_BOOM, 3.0F, 1.0F);
                    target.method_5643(sonicBoom(warden), 10.0F);
                    double yKnockback = 0.5D
                        * (1.0D
                           - target.method_26825(class_5134.field_23718));
                    double xzKnockback = 2.5D
                        * (1.0D
                           - target.method_26825(class_5134.field_23718));
                    target.method_5762(
                        distance.method_10216() * xzKnockback,
                        distance.method_10214() * yKnockback,
                        distance.method_10215() * xzKnockback
                    );
                });
        }
    }

    @Override
    protected void stop(class_3218 level, Warden warden, long time) {
        SonicBoom.setCooldown(warden, 60L);
    }

    public static void setCooldown(class_1309 entity, long cooldown) {
        entity.method_18868().method_24525(
            WBMemoryModules.SONIC_BOOM_COOLDOWN.get(), class_3902.field_17274, cooldown
        );
    }

    @SuppressWarnings("ConstantConditions")
    public static class_1282 sonicBoom(class_1297 entity) {
        return ((DamageSourceAccessor) new class_1285("sonic_boom", entity))
            .callBypassArmor()
            .method_5515();
    }
}