package com.cursedcauldron.wildbackport.common.entities.warden;

import java.util.Arrays;
import net.minecraft.class_156;
import net.minecraft.class_3414;
import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;

//<>

public enum Angriness {
    CALM(0, WBSoundEvents.WARDEN_AMBIENT, WBSoundEvents.WARDEN_LISTENING),
    AGITATED(40, WBSoundEvents.WARDEN_AGITATED, WBSoundEvents.WARDEN_LISTENING_ANGRY),
    ANGRY(80, WBSoundEvents.WARDEN_ANGRY, WBSoundEvents.WARDEN_LISTENING_ANGRY);

    private static final Angriness[] VALUES = class_156.method_654(
        Angriness.values(),
        values -> Arrays.sort(values, (a, b) -> Integer.compare(b.threshold, a.threshold))
    );
    private final int threshold;
    private final class_3414 sound;
    private final class_3414 listeningSound;

    Angriness(int threshold, class_3414 sound, class_3414 listeningSound) {
        this.threshold = threshold;
        this.sound = sound;
        this.listeningSound = listeningSound;
    }

    public int getThreshold() {
        return this.threshold;
    }

    public class_3414 getSound() {
        return this.sound;
    }

    public class_3414 getListeningSound() {
        return this.listeningSound;
    }

    public static Angriness getForAnger(int anger) {
        for (Angriness angriness : VALUES) {
            if (anger >= angriness.threshold) {
                return angriness;
            }
        }

        return CALM;
    }

    public boolean isAngry() {
        return this == ANGRY;
    }
}