package com.cursedcauldron.wildbackport.common.entities.warden;

import java.util.Optional;
import net.minecraft.class_1299;
import net.minecraft.class_1308;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3532;
import net.minecraft.class_3730;

public class WardenSpawnHelper {
    public static <T extends class_1308> Optional<T> trySpawnMob(
        class_1299<T> type,
        class_3730 spawnType,
        class_3218 level,
        class_2338 pos,
        int tries,
        int xzRange,
        int yRange
    ) {
        class_2338.class_2339 mutable = pos.method_25503();

        for (int i = 0; i < tries; ++i) {
            int x = class_3532.method_32751(level.field_9229, -xzRange, xzRange);
            int z = class_3532.method_32751(level.field_9229, -xzRange, xzRange);
            mutable.method_25504(pos, x, yRange, z);
            if (level.method_8621().method_11952(mutable)
                && moveToPossibleSpawnPosition(level, yRange, mutable)) {
                T mob = type.method_5888(
                    level, null, null, null, mutable, spawnType, false, false
                );
                if (mob != null) {
                    if (mob.method_5979(level, spawnType)
                        && mob.method_5957(level)) {
                        level.method_30771(mob);
                        return Optional.of(mob);
                    }

                    mob.method_31472();
                }
            }
        }

        return Optional.empty();
    }

    private static boolean moveToPossibleSpawnPosition(
        class_3218 level, int yRange, class_2338.class_2339 pos
    ) {
        class_2338.class_2339 toPos = (new class_2338.class_2339()).method_10101(pos);
        class_2680 toState = level.method_8320(toPos);

        for (int i = yRange; i >= -yRange; --i) {
            pos.method_10098(class_2350.field_11033);
            toPos.method_25505(pos, class_2350.field_11036);
            class_2680 state = level.method_8320(pos);
            if (canSpawnOn(level, pos, state, toPos, toState)) {
                pos.method_10098(class_2350.field_11036);
                return true;
            }

            toState = state;
        }

        return false;
    }

    public static boolean canSpawnOn(
        class_3218 level,
        class_2338 pos,
        class_2680 state,
        class_2338 toPos,
        class_2680 toState
    ) {
        return toState.method_26220(level, toPos).method_1110()
            && class_2248.method_9501(state.method_26220(level, pos), class_2350.field_11036);
    }
}