package com.cursedcauldron.wildbackport.common.items;

import java.util.List;
import java.util.function.Predicate;
import net.minecraft.class_1268;
import net.minecraft.class_1271;
import net.minecraft.class_1297;
import net.minecraft.class_1301;
import net.minecraft.class_1657;
import net.minecraft.class_1690;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_3468;
import net.minecraft.class_3959;
import net.minecraft.class_5712;
import com.cursedcauldron.wildbackport.common.entities.ChestBoat;
import com.cursedcauldron.wildbackport.common.entities.MangroveBoat;

//<>

public class ChestBoatItem extends class_1792 {
    private static final Predicate<class_1297> RIDERS
        = class_1301.field_6155.and(class_1297::method_5863);
    private final class_1690.class_1692 type;
    private final boolean chested;

    public ChestBoatItem(boolean chested, class_1690.class_1692 type, class_1793 properties) {
        super(properties);
        this.chested = chested;
        this.type = type;
    }

    @Override
    public class_1271<class_1799>
    method_7836(class_1937 level, class_1657 player, class_1268 hand) {
        class_1799 stack = player.method_5998(hand);
        class_239 hitResult = method_7872(level, player, class_3959.class_242.field_1347);
        if (hitResult.method_17783() == class_239.class_240.field_1333) {
            return class_1271.method_22430(stack);
        } else {
            class_243 viewVector = player.method_5828(1.0F);
            List<class_1297> entities = level.method_8333(
                player,
                player.method_5829()
                    .method_18804(viewVector.method_1021(5.0D))
                    .method_1014(1.0D),
                RIDERS
            );
            if (!entities.isEmpty()) {
                class_243 eyePosition = player.method_33571();
                for (class_1297 entity : entities) {
                    class_238 box = entity.method_5829().method_1014(entity.method_5871());
                    if (box.method_1006(eyePosition))
                        return class_1271.method_22430(stack);
                }
            }

            if (hitResult.method_17783() == class_239.class_240.field_1332) {
                MangroveBoat boat = this.create(level, hitResult.method_17784());
                boat.method_7541(this.type);
                boat.method_36456(player.method_36454());
                if (!level.method_8587(boat, boat.method_5829())) {
                    return class_1271.method_22431(stack);
                } else {
                    if (!level.field_9236) {
                        level.method_8649(boat);
                        level.method_32888(
                            player,
                            class_5712.field_28738,
                            new class_2338(hitResult.method_17784())
                        );
                        if (!player.method_31549().field_7477)
                            stack.method_7934(1);
                    }

                    player.method_7259(class_3468.field_15372.method_14956(this));
                    return class_1271.method_29237(
                        stack, level.field_9236
                    );
                }
            } else {
                return class_1271.method_22430(stack);
            }
        }
    }

    public MangroveBoat create(class_1937 level, class_243 pos) {
        if (this.chested) {
            return new ChestBoat(level, pos.field_1352, pos.field_1351, pos.field_1350);
        } else {
            return new MangroveBoat(level, pos.field_1352, pos.field_1351, pos.field_1350);
        }
    }
}