package com.cursedcauldron.wildbackport.common.items;

import javax.annotation.Nullable;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_3532;
import net.minecraft.class_4208;
import net.minecraft.class_638;
import net.minecraft.class_6395;

public class CompassItemPropertyFunction implements class_6395 {
    private final CompassItemPropertyFunction.CompassWobble wobble
        = new CompassItemPropertyFunction.CompassWobble();
    private final CompassItemPropertyFunction.CompassWobble wobbleRandom
        = new CompassItemPropertyFunction.CompassWobble();
    public final CompassItemPropertyFunction.CompassTarget compassTarget;

    public CompassItemPropertyFunction(CompassItemPropertyFunction.CompassTarget target) {
        this.compassTarget = target;
    }

    public float unclampedCall(
        class_1799 p_234960_,
        @Nullable class_638 p_234961_,
        @Nullable class_1309 p_234962_,
        int p_234963_
    ) {
        class_1297 entity
            = p_234962_ != null ? p_234962_ : p_234960_.method_27319();
        if (entity == null) {
            return 0.0F;
        } else {
            p_234961_ = this.tryFetchLevelIfMissing(entity, p_234961_);
            return p_234961_ == null
                ? 0.0F
                : this.getCompassRotation(p_234960_, p_234961_, p_234963_, entity);
        }
    }

    private float getCompassRotation(
        class_1799 p_234955_, class_638 p_234956_, int p_234957_, class_1297 p_234958_
    ) {
        class_4208 globalpos = this.compassTarget.getPos(p_234956_, p_234955_, p_234958_);
        long i = p_234956_.method_8510();
        return !this.isValidCompassTargetPos(p_234958_, globalpos)
            ? this.getRandomlySpinningRotation(p_234957_, i)
            : this.getRotationTowardsCompassTarget(p_234958_, i, globalpos.method_19446());
    }

    private float getRandomlySpinningRotation(int p_234937_, long p_234938_) {
        if (this.wobbleRandom.shouldUpdate(p_234938_)) {
            this.wobbleRandom.update(p_234938_, Math.random());
        }

        double d0 = this.wobbleRandom.rotation
            + (double) ((float) this.hash(p_234937_) / 2.14748365E9F);
        return class_3532.method_15341((float) d0, 1.0F);
    }

    private float getRotationTowardsCompassTarget(
        class_1297 p_234942_, long p_234943_, class_2338 p_234944_
    ) {
        double d0 = this.getAngleFromEntityToPos(p_234942_, p_234944_);
        double d1 = this.getWrappedVisualRotationY(p_234942_);
        if (p_234942_ instanceof class_1657 player) {
            if (player.method_7340()) {
                if (this.wobble.shouldUpdate(p_234943_)) {
                    this.wobble.update(p_234943_, 0.5D - (d1 - 0.25D));
                }

                double d3 = d0 + this.wobble.rotation;
                return class_3532.method_15341((float) d3, 1.0F);
            }
        }

        double d2 = 0.5D - (d1 - 0.25D - d0);
        return class_3532.method_15341((float) d2, 1.0F);
    }

    @javax.annotation.Nullable
    private class_638 tryFetchLevelIfMissing(
        class_1297 p_234946_, @javax.annotation.Nullable class_638 p_234947_
    ) {
        return p_234947_ == null && p_234946_.field_6002 instanceof class_638
            ? (class_638) p_234946_.field_6002
            : p_234947_;
    }

    private boolean isValidCompassTargetPos(
        class_1297 p_234952_, @javax.annotation.Nullable class_4208 p_234953_
    ) {
        return p_234953_ != null && p_234953_.method_19442() == p_234952_.field_6002.method_27983()
            && !(p_234953_.method_19446().method_19770(p_234952_.method_19538()) < (double) 1.0E-5F
            );
    }

    private double getAngleFromEntityToPos(class_1297 p_234949_, class_2338 p_234950_) {
        class_243 vec3 = class_243.method_24953(p_234950_);
        return Math.atan2(vec3.method_10215() - p_234949_.method_23321(), vec3.method_10216() - p_234949_.method_23317())
            / (double) ((float) Math.PI * 2F);
    }

    private double getWrappedVisualRotationY(class_1297 entity) {
        return class_3532.method_15367(entity.method_36454() / 360.0F, 1.0D);
    }

    private int hash(int p_234935_) {
        return p_234935_ * 1327217883;
    }

    public interface CompassTarget {
        @Nullable
        class_4208 getPos(class_638 level, class_1799 stack, class_1297 entity);
    }

    static class CompassWobble {
        double rotation;
        private double deltaRotation;
        private long lastUpdateTick;

        boolean shouldUpdate(long updateTick) {
            return this.lastUpdateTick != updateTick;
        }

        void update(long updateTick, double rotation) {
            this.lastUpdateTick = updateTick;
            double d0 = rotation - this.rotation;
            d0 = class_3532.method_15367(d0 + 0.5D, 1.0D) - 0.5D;
            this.deltaRotation += d0 * 0.1D;
            this.deltaRotation *= 0.8D;
            this.rotation = class_3532.method_15367(this.rotation + this.deltaRotation, 1.0D);
        }
    }
}