package com.cursedcauldron.wildbackport.common.items;

import java.util.Iterator;
import java.util.List;
import java.util.Optional;
import java.util.Random;
import net.minecraft.class_124;
import net.minecraft.class_1268;
import net.minecraft.class_1271;
import net.minecraft.class_156;
import net.minecraft.class_1657;
import net.minecraft.class_1761;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_1839;
import net.minecraft.class_1937;
import net.minecraft.class_2371;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_2960;
import net.minecraft.class_3419;
import net.minecraft.class_5250;
import net.minecraft.class_5321;
import net.minecraft.class_6862;
import net.minecraft.class_6880;
import com.cursedcauldron.wildbackport.common.registry.WBGameEvents;
import com.cursedcauldron.wildbackport.common.registry.WBItems;
import com.cursedcauldron.wildbackport.common.registry.WBRegistries;
import org.jetbrains.annotations.Nullable;

public class GoatHornItem extends class_1792 {
    private static final String INSTRUMENT_KEY = "instrument";
    private class_6862<Instrument> instruments;

    public GoatHornItem(class_1793 properties, class_6862<Instrument> instrumentTag) {
        super(properties);
        this.instruments = instrumentTag;
    }

    @Override
    public void method_7851(
        class_1799 stack,
        @Nullable class_1937 level,
        List<class_2561> components,
        class_1836 tooltipFlag
    ) {
        super.method_7851(stack, level, components, tooltipFlag);
        Optional<class_5321<Instrument>> instrument
            = this.getInstrument(stack).flatMap(class_6880::unwrapKey);
        if (instrument.isPresent()) {
            class_5250 component = new class_2588(
                class_156.method_646(INSTRUMENT_KEY, instrument.get().location())
            );
            components.add(component.method_27692(class_124.field_1080));
        }
    }

    public static class_1799
    getStackForInstrument(class_1792 item, class_6880<Instrument> instrument) {
        class_1799 stack = new class_1799(item);
        setInstrument(stack, instrument);
        return stack;
    }

    public static void
    setRandomInstrumentFromTag(class_1799 stack, class_6862<Instrument> tag, Random random) {
        Optional<class_6880<Instrument>> instrument
            = WBRegistries.INSTRUMENT.registry().getTag(tag).flatMap(
                holders -> holders.getRandomElement(random)
            );
        instrument.ifPresent(holder -> setInstrument(stack, holder));
    }

    private static void setInstrument(class_1799 stack, class_6880<Instrument> instrument) {
        stack.method_7948().method_10582(
            INSTRUMENT_KEY,
            instrument.unwrapKey()
                .orElseThrow(() -> {
                    return new IllegalStateException("Invalid instrument");
                })
                .location()
                .toString()
        );
    }

    @Override
    public void method_7850(class_1761 tab, class_2371<class_1799> stacks) {
        if (this.method_7877(tab)) {
            for (class_6880<Instrument> holder :
                 WBRegistries.INSTRUMENT.registry().getTagOrEmpty(this.instruments)) {
                //                stacks.add(getStackForInstrument(WBItems.GOAT_HORN.get(),
                //                holder));
            }
        }
    }

    @Override
    public class_1271<class_1799>
    method_7836(class_1937 level, class_1657 player, class_1268 hand) {
        class_1799 stack = player.method_5998(hand);
        Optional<class_6880<Instrument>> holder = this.getInstrument(stack);
        if (holder.isPresent()) {
            Instrument instrument = holder.get().value();
            player.method_6019(hand);
            playSound(level, player, instrument);
            player.method_7357().method_7906(this, instrument.useDuration());
            return class_1271.method_22428(stack);
        } else {
            return class_1271.method_22431(stack);
        }
    }

    @Override
    public int method_7881(class_1799 stack) {
        Optional<class_6880<Instrument>> instrument = this.getInstrument(stack);
        return instrument.map(holder -> holder.value().useDuration()).orElse(0);
    }

    private Optional<class_6880<Instrument>> getInstrument(class_1799 stack) {
        class_2487 tag = stack.method_7969();
        if (tag != null) {
            class_2960 location
                = class_2960.method_12829(tag.method_10558("instrument"));
            if (location != null) {
                return WBRegistries.INSTRUMENT.registry().getHolder(
                    class_5321.method_29179(WBRegistries.INSTRUMENT.key(), location)
                );
            }
        }

        Iterator<class_6880<Instrument>> instruments = WBRegistries.INSTRUMENT.registry()
                                                       .getTagOrEmpty(this.instruments)
                                                       .iterator();
        return instruments.hasNext() ? Optional.of(instruments.next()) : Optional.empty();
    }

    @Override
    public class_1839 method_7853(class_1799 stack) {
        return class_1839.field_27079;
    }

    private static void playSound(class_1937 level, class_1657 player, Instrument instrument) {
        level.method_8396(
            player,
            player,
            instrument.soundEvent(),
            class_3419.field_15247,
            instrument.range() / 16.0F,
            1.0F
        );
        level.method_33596(WBGameEvents.INSTRUMENT_PLAY.get(), player);
    }
}