package com.cursedcauldron.wildbackport.common.items;

import java.util.List;
import java.util.function.Supplier;
import javax.annotation.Nullable;
import net.minecraft.class_124;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1474;
import net.minecraft.class_1657;
import net.minecraft.class_1755;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_3218;
import net.minecraft.class_3414;
import net.minecraft.class_3419;
import net.minecraft.class_3611;
import net.minecraft.class_3730;
import net.minecraft.class_5250;
import net.minecraft.class_5712;
import net.minecraft.class_5761;

//<>

public class TadpoleBucketItem extends class_1755 {
    private final Supplier<? extends class_1299<?>> entityType;
    private final Supplier<? extends class_3414> emptySound;

    public TadpoleBucketItem(
        Supplier<? extends class_1299<?>> entityType,
        class_3611 fluid,
        Supplier<? extends class_3414> emptySound,
        class_1792.class_1793 properties
    ) {
        super(fluid, properties);
        this.entityType = entityType;
        this.emptySound = emptySound;
    }

    public void method_7728(
        @Nullable class_1657 player, class_1937 level, class_1799 stack, class_2338 pos
    ) {
        if (level instanceof class_3218 server) {
            this.spawn(server, stack, pos);
            level.method_32888(player, class_5712.field_28738, pos);
        }
    }

    protected void
    method_7727(@Nullable class_1657 player, class_1936 access, class_2338 pos) {
        access.method_8396(
            player, pos, this.emptySound.get(), class_3419.field_15254, 1.0F, 1.0F
        );
    }

    private void spawn(class_3218 level, class_1799 stack, class_2338 pos) {
        class_1297 entity = this.entityType.get().method_5894(
            level, stack, null, pos, class_3730.field_16473, true, false
        );
        if (entity instanceof class_5761 bucketable) {
            bucketable.method_35170(stack.method_7948());
            bucketable.method_6454(true);
        }
    }

    public void method_7851(
        class_1799 stack,
        @Nullable class_1937 level,
        List<class_2561> components,
        class_1836 tooltip
    ) {
        if (this.entityType.get() == class_1299.field_6111) {
            class_2487 tag = stack.method_7969();
            if (tag != null && tag.method_10573("BucketVariantTag", 3)) {
                int variant = tag.method_10550("BucketVariantTag");
                class_124[] format
                    = new class_124[] { class_124.field_1056, class_124.field_1080 };
                String base = "color.minecraft." + class_1474.method_6652(variant);
                String pattern
                    = "color.minecraft." + class_1474.method_6651(variant);

                for (int i = 0; i < class_1474.field_6879.length; ++i) {
                    if (variant == class_1474.field_6879[i]) {
                        components.add(
                            (new class_2588(class_1474.method_6649(i)))
                                .method_27695(format)
                        );
                        return;
                    }
                }

                components.add(
                    new class_2588(class_1474.method_6657(variant))
                        .method_27695(format)
                );
                class_5250 component = new class_2588(base);
                if (!base.equals(pattern))
                    component.method_27693(", ").method_10852(new class_2588(pattern));

                component.method_27695(format);
                components.add(component);
            }
        }
    }
}