package com.cursedcauldron.wildbackport.common.registry;

import java.util.function.Supplier;
import net.minecraft.class_1959;
import net.minecraft.class_2378;
import net.minecraft.class_2893;
import net.minecraft.class_2960;
import net.minecraft.class_3532;
import net.minecraft.class_3864;
import net.minecraft.class_4763;
import net.minecraft.class_4968;
import net.minecraft.class_5321;
import net.minecraft.class_5458;
import net.minecraft.class_5463;
import net.minecraft.class_5483;
import net.minecraft.class_5485;
import net.minecraft.class_6811;
import net.minecraft.class_6819;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;
import com.cursedcauldron.wildbackport.core.mixin.access.OverworldBiomesAccessor;

public class WBBiomes {
    public static final CoreRegistry<class_1959> BIOMES
        = CoreRegistry.create(class_5458.field_25933, "minecraft");

    public static final class_5321<class_1959> MANGROVE_SWAMP
        = create("mangrove_swamp", WBBiomes::mangroveSwamp);
    public static final class_5321<class_1959> DEEP_DARK
        = create("deep_dark", WBBiomes::deepDark);

    // Mangrove Swamp
    public static class_1959 mangroveSwamp() {
        class_5483.class_5496 spawn = new class_5483.class_5496();
        class_3864.method_30581(spawn);
        class_5485.class_5495 generation
            = new class_5485.class_5495();
        class_3864.method_16990(generation);
        OverworldBiomesAccessor.callGlobalOverworldGeneration(generation);
        class_3864.method_38568(generation);
        class_3864.method_17011(generation);
        generation.method_30992(
            class_2893.class_2895.field_13178,
            class_6819.field_36169
        );
        generation.method_30992(
            class_2893.class_2895.field_13178,
            class_6819.field_36175
        );
        generation.method_30992(
            class_2893.class_2895.field_13178,
            class_6819.field_36180
        );
        generation.method_30992(
            class_2893.class_2895.field_13178, class_6811.field_35971
        );
        return new class_1959.class_1960()
            .method_8738(class_1959.class_1961.field_9364)
            .method_8735(class_1959.class_1963.field_9382)
            .method_8747(0.8F)
            .method_8727(0.9F)
            .method_24379(
                new class_4763.class_4764()
                    .method_24395(3832426)
                    .method_24397(5077600)
                    .method_24392(12638463)
                    .method_30820(calculateSkyColor(0.8f))
                    .method_30821(9285927)
                    .method_30818(class_4763.class_5486.field_26428)
                    .method_24943(class_4968.field_23146)
                    .method_24391()
            )
            .method_30974(spawn.method_31007())
            .method_30973(generation.method_30987())
            .method_30972();
    }

    // Deep Dark
    public static class_1959 deepDark() {
        class_5483.class_5496 spawn = new class_5483.class_5496();
        class_5485.class_5495 generation
            = new class_5485.class_5495();
        generation.method_30991(class_2893.class_2894.field_13169, class_5463.field_33119);
        generation.method_30991(class_2893.class_2894.field_13169, class_5463.field_34968);
        generation.method_30991(class_2893.class_2894.field_13169, class_5463.field_33120);
        class_3864.method_32236(generation);
        class_3864.method_17004(generation);
        class_3864.method_17005(generation);
        class_3864.method_16999(generation);
        class_3864.method_16981(generation);
        class_3864.method_17006(generation, true);
        class_3864.method_17010(generation);
        class_3864.method_16974(generation);
        class_3864.method_16982(generation);
        class_3864.method_16984(generation);
        return new class_1959.class_1960()
            .method_8738(class_1959.class_1961.field_29217)
            .method_8735(class_1959.class_1963.field_9382)
            .method_8747(0.8F)
            .method_8727(0.4F)
            .method_24379(new class_4763.class_4764()
                                .method_24395(4159204)
                                .method_24397(329011)
                                .method_24392(12638463)
                                .method_30820(calculateSkyColor(0.8F))
                                .method_24943(class_4968.field_23146
                                )
                                .method_24391())
            .method_30974(spawn.method_31007())
            .method_30973(generation.method_30987())
            .method_30972();
    }

    // Registry

    private static class_5321<class_1959> create(String key, Supplier<class_1959> biome) {
        BIOMES.register(key, biome);
        return class_5321.method_29179(
            class_2378.field_25114, new class_2960("minecraft", key)
        );
    }

    protected static int calculateSkyColor(float temperature) {
        float modifier = temperature / 3.0F;
        modifier = class_3532.method_15363(modifier, -1.0F, 1.0F);
        return class_3532.method_15369(0.62222224F - modifier * 0.05F, 0.5F + modifier * 0.1F, 1.0F);
    }
}
