package com.cursedcauldron.wildbackport.common.registry.worldgen;

import java.util.Arrays;
import java.util.Optional;
import java.util.stream.Collectors;

import com.cursedcauldron.wildbackport.common.tag.WBBiomeTags;
import com.cursedcauldron.wildbackport.common.utils.SupplierHolder;
import com.cursedcauldron.wildbackport.common.worldgen.features.AncientCityFeature;
import com.cursedcauldron.wildbackport.common.worldgen.structure.AncientCityStructurePieces;
import com.cursedcauldron.wildbackport.common.worldgen.structure.processors.BlockTagRotProcessor;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;

import net.anvilcraft.anvillib.worldgen.AdvancedStructurePoolFeatureConfig;
import net.minecraft.class_1311;
import net.minecraft.class_2378;
import net.minecraft.class_3828;
import net.minecraft.class_5312;
import net.minecraft.class_5458;
import net.minecraft.class_6012;
import net.minecraft.class_6872;
import net.minecraft.class_6873;
import net.minecraft.class_6880;
import net.minecraft.class_7059;
import net.minecraft.class_7061;

public class WBStructures {
    public static final CoreRegistry<class_5312<?, ?>>
        CONFIGURED_STRUCTURE_FEATURES = CoreRegistry.create(
            class_5458.field_25930, "minecraft"
        );

    public static final CoreRegistry<class_7059> STRUCTURE_SETS
        = CoreRegistry.create(class_5458.field_37231, "minecraft");

    public static final CoreRegistry<class_3828<?>> STRUCTURE_PROCESSORS
        = CoreRegistry.create(class_2378.field_16794, "minecraft");

    public static final class_6880<class_3828<BlockTagRotProcessor>> BLOCK_TAG_ROT
        = SupplierHolder.createAndRegister(
            STRUCTURE_PROCESSORS, "block_rot_alec", () -> () -> BlockTagRotProcessor.CODEC
        );

    public static final class_6880<class_5312<?, ?>> ANCIENT_CITY
        = SupplierHolder.createAndRegister(
            CONFIGURED_STRUCTURE_FEATURES,
            "ancient_city",
            ()
                -> ((AncientCityFeature) WBStructureFeatures.ANCIENT_CITY.comp_349())
                       .method_41135(
                           new AdvancedStructurePoolFeatureConfig(
                               AncientCityStructurePieces.START,
                               7,
                               116,
                               true
                           ),
                           WBBiomeTags.HAS_ANCIENT_CITY,
                           true,
                           Arrays.stream(class_1311.values())
                               .collect(Collectors.toMap(
                                   mobCategory
                                   -> mobCategory,
                                   mobCategory
                                   -> new class_7061(
                                       class_7061.class_7062.field_37200,
                                       class_6012.method_34990()
                                   )
                               ))
                       )
        );

    public static final class_6880<class_7059> ANCIENT_CITIES
        = SupplierHolder.createAndRegister(
            STRUCTURE_SETS,
            "ancient_cities",
            ()
                -> new class_7059(
                    ANCIENT_CITY,
                    new class_6872(
                        24, 8, class_6873.field_36421, 20083232
                    )
                )
        );

    public static void setup() {
        AncientCityStructurePieces.bootstrap();
    }
}
