package com.cursedcauldron.wildbackport.common.utils;

import java.util.function.Supplier;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2394;
import net.minecraft.class_243;
import net.minecraft.class_3218;
import net.minecraft.class_3532;
import net.minecraft.class_6017;

public class ParticleUtils {
    public static void spawnParticles(
        class_1937 world,
        class_2338 pos,
        class_2394 effect,
        class_6017 count,
        class_2350 direction,
        Supplier<class_243> velocity,
        double offset
    ) {
        int sample = count.method_35008(world.method_8409());
        for (int i = 0; i < sample; ++i) {
            spawnParticle(world, pos, direction, effect, velocity.get(), offset);
        }
    }

    public static void spawnParticle(
        class_1937 level,
        class_2338 pos,
        class_2350 direction,
        class_2394 effect,
        class_243 velocity,
        double offset
    ) {
        class_243 center = class_243.method_24953(pos);
        int xStep = direction.method_10148();
        int yStep = direction.method_10164();
        int zStep = direction.method_10165();
        double x = center.field_1352
            + (xStep == 0 ? class_3532.method_15366(level.method_8409(), -0.5D, 0.5D)
                          : (double) xStep * offset);
        double y = center.field_1351
            + (yStep == 0 ? class_3532.method_15366(level.method_8409(), -0.5D, 0.5D)
                          : (double) yStep * offset);
        double z = center.field_1350
            + (zStep == 0 ? class_3532.method_15366(level.method_8409(), -0.5D, 0.5D)
                          : (double) zStep * offset);
        double xVelocity = xStep == 0 ? velocity.method_10216() : 0.0D;
        double yVelocity = yStep == 0 ? velocity.method_10214() : 0.0D;
        double zVelocity = zStep == 0 ? velocity.method_10215() : 0.0D;
        class_3218 server = level instanceof class_3218 side ? side : null;
        if (server != null)
            server.method_14199(
                effect, x, y, z, 1, xVelocity, yVelocity, zVelocity, 0.0D
            );
    }
}