package com.cursedcauldron.wildbackport.common.utils;

import java.util.Optional;
import java.util.function.Predicate;
import java.util.function.Supplier;
import java.util.stream.Stream;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import net.minecraft.class_6862;
import net.minecraft.class_6880;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;
import com.mojang.datafixers.util.Either;

public class SupplierHolder<E, T extends E> implements class_6880<T> {
    public class_5321<T> key;
    public Supplier<T> supplier;

    public SupplierHolder(
        class_5321<? extends class_2378<E>> regKey, String loc, Supplier<T> supplier
    ) {
        this(regKey, new class_2960(loc), supplier);
    }

    @SuppressWarnings("unchecked")
    public SupplierHolder(
        class_5321<? extends class_2378<E>> regKey,
        class_2960 loc,
        Supplier<T> supplier
    ) {
        this((class_5321<T>) class_5321.method_29179(regKey, loc), supplier);
    }

    public SupplierHolder(class_5321<T> key, Supplier<T> supplier) {
        this.key = key;
        this.supplier = supplier;
    }

    public static <E, T extends E> SupplierHolder<E, T>
    createAndRegister(CoreRegistry<E> reg, String loc, Supplier<T> supplier) {
        return new SupplierHolder<E, T>(
            reg.registry.method_30517(), loc, reg.register(loc, supplier)
        );
    }

    @Override
    public boolean method_40226(class_2960 resourceLocation) {
        return this.key.method_29177().equals(resourceLocation);
    }

    @Override
    public boolean method_40225(class_5321<T> resourceKey) {
        return this.key.equals(resourceKey);
    }

    @Override
    public boolean method_40224(Predicate<class_5321<T>> predicate) {
        return predicate.test(this.key);
    }

    @Override
    public boolean method_40220(class_6862<T> tagKey) {
        return false;
    }

    @Override
    public boolean method_40227() {
        return true;
    }

    @Override
    public boolean method_40222(class_2378<T> registry) {
        return registry.method_30517().method_29177().equals(this.key.method_41185());
    }

    @Override
    public class_6882 method_40231() {
        return class_6880.class_6882.field_36446;
    }

    @Override
    public Stream<class_6862<T>> method_40228() {
        return Stream.empty();
    }

    @Override
    public Either<class_5321<T>, T> method_40229() {
        // This NEEDS to always return a key and not a value. Otherwise, Mojank's shitty chunk
        // serialization breaks.
        return Either.left(this.key);
    }

    @Override
    public Optional<class_5321<T>> method_40230() {
        return Optional.of(this.key);
    }

    @Override
    public T comp_349() {
        return this.supplier.get();
    }
}
