package com.cursedcauldron.wildbackport.common.worldgen;

import com.cursedcauldron.wildbackport.common.registry.WBBiomes;
import com.cursedcauldron.wildbackport.common.registry.entity.WBEntityTypes;
import com.cursedcauldron.wildbackport.common.registry.worldgen.WBWorldGeneration;
import com.cursedcauldron.wildbackport.core.api.worldgen.BiomeModifier;
import com.cursedcauldron.wildbackport.core.api.worldgen.BiomeWriter;
import net.minecraft.class_1299;
import net.minecraft.class_1311;
import net.minecraft.class_1959;
import net.minecraft.class_2893;

//<>

public class WorldGenerator {
    public static void setup() {
        BiomeModifier.add(WorldGenerator::mangroveSwamp, WBBiomes.MANGROVE_SWAMP);
        BiomeModifier.add(WorldGenerator::deepDark, WBBiomes.DEEP_DARK);

        BiomeModifier.add(WorldGenerator::addFrogs, class_1959.class_1961.field_9364);
    }

    public static void mangroveSwamp(BiomeWriter writer) {
        writer.addFeature(
            class_2893.class_2895.field_13176,
            WBWorldGeneration.DISK_GRASS_PLACED
        );
        writer.addFeature(
            class_2893.class_2895.field_13178,
            WBWorldGeneration.TREES_MANGROVE_PLACED
        );

        writer.addSpawn(class_1311.field_6302, class_1299.field_6069, 1, 1, 1);
        writer.addSpawn(class_1311.field_24460, class_1299.field_6111, 25, 8, 8);
    }

    public static void deepDark(BiomeWriter writer) {
        writer.addFeature(
            class_2893.class_2895.field_13177,
            WBWorldGeneration.SCULK_VEIN_PLACED
        );
        writer.addFeature(
            class_2893.class_2895.field_13177,
            WBWorldGeneration.SCULK_PATCH_DEEP_DARK_PLACED
        );
    }

    public static void addFrogs(BiomeWriter writer) {
        writer.addSpawn(class_1311.field_6294, WBEntityTypes.FROG.get(), 10, 2, 5);
    }
}
