package com.cursedcauldron.wildbackport.common.worldgen.decorator;

import java.util.List;
import java.util.Random;
import java.util.function.BiConsumer;
import net.minecraft.class_2338;
import net.minecraft.class_2541;
import net.minecraft.class_2680;
import net.minecraft.class_2746;
import net.minecraft.class_3031;
import net.minecraft.class_3746;
import net.minecraft.class_4661;
import net.minecraft.class_4662;
import net.minecraft.class_4663;
import com.cursedcauldron.wildbackport.common.registry.worldgen.WBTreeDecorators;
import com.mojang.serialization.Codec;

//<>

public class WeightedLeaveVineDecorator extends class_4662 {
    public static final Codec<WeightedLeaveVineDecorator> CODEC
        = Codec.floatRange(0.0F, 1.0F)
              .fieldOf("probability")
              .xmap(
                  WeightedLeaveVineDecorator::new,
                  decorator -> { return decorator.probability; }
              )
              .codec();
    private final float probability;

    public WeightedLeaveVineDecorator(float probability) {
        this.probability = probability;
    }

    @Override
    public void method_23469(
        class_3746 level,
        BiConsumer<class_2338, class_2680> replacer,
        Random random,
        List<class_2338> trunkPositions,
        List<class_2338> foliagePositions
    ) {
        foliagePositions.forEach(pos -> {
            if (random.nextFloat() < this.probability && class_3031.method_27370(level, pos.method_10067()))
                addHangingVine(level, pos.method_10067(), class_2541.field_11702, replacer);
            if (random.nextFloat() < this.probability && class_3031.method_27370(level, pos.method_10078()))
                addHangingVine(level, pos.method_10078(), class_2541.field_11696, replacer);
            if (random.nextFloat() < this.probability
                && class_3031.method_27370(level, pos.method_10095()))
                addHangingVine(level, pos.method_10095(), class_2541.field_11699, replacer);
            if (random.nextFloat() < this.probability
                && class_3031.method_27370(level, pos.method_10072()))
                addHangingVine(level, pos.method_10072(), class_2541.field_11706, replacer);
        });
    }

    private static void addHangingVine(
        class_3746 level,
        class_2338 pos,
        class_2746 property,
        BiConsumer<class_2338, class_2680> replacer
    ) {
        class_4661.method_23471(replacer, pos, property);
        pos = pos.method_10074();

        for (int i = 4; class_3031.method_27370(level, pos) && i > 0; --i) {
            class_4661.method_23471(replacer, pos, property);
            pos = pos.method_10074();
        }
    }

    @Override
    protected class_4663<?> method_28893() {
        return WBTreeDecorators.WEIGHTED_LEAVE_VINE.get();
    }
}