package com.cursedcauldron.wildbackport.common.worldgen.features;

import java.util.Random;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3031;
import net.minecraft.class_5281;
import net.minecraft.class_5821;
import com.mojang.serialization.Codec;

public class GrassDiskFeature extends class_3031<GrassDiskConfiguration> {
    public GrassDiskFeature(Codec<GrassDiskConfiguration> codec) {
        super(codec);
    }

    @Override
    public boolean method_13151(class_5821<GrassDiskConfiguration> context) {
        GrassDiskConfiguration config = context.config();
        class_2338 pos = context.origin();
        class_5281 level = context.level();
        Random random = context.random();
        boolean place = false;
        int y = pos.method_10264();
        int topY = y + config.halfHeight();
        int bottomY = y - config.halfHeight() - 1;
        int radius = config.radius().sample(random);
        class_2338.class_2339 mutable = new class_2338.class_2339();

        for (class_2338 position : class_2338.method_10097(
                 pos.method_10069(-radius, 0, -radius), pos.method_10069(radius, 0, radius)
             )) {
            int x = position.method_10263() - position.method_10263();
            int z = position.method_10260() - position.method_10260();
            if (x * x + z * z <= radius * radius) {
                place |= this.placeBlock(
                    config, level, random, topY, bottomY, mutable.method_10101(position)
                );
            }
        }

        return place;
    }

    protected boolean placeBlock(
        GrassDiskConfiguration config,
        class_5281 level,
        Random random,
        int topY,
        int bottomY,
        class_2338.class_2339 pos
    ) {
        boolean place = false;
        for (int y = topY; y > bottomY; y--) {
            pos.method_33098(y);
            if (config.target().test(level, pos)) {
                class_2680 state
                    = config.stateProvider().getBlockState(level, random, pos);
                level.method_8652(pos, state, 2);
                this.method_37256(level, pos);
                place = true;
            }
        }

        return place;
    }
}