package com.cursedcauldron.wildbackport.common.worldgen.features;

import java.util.Random;
import net.minecraft.class_1936;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3031;
import net.minecraft.class_5281;
import net.minecraft.class_5821;
import com.cursedcauldron.wildbackport.common.blocks.SculkShriekerBlock;
import com.cursedcauldron.wildbackport.common.blocks.SculkSpreadManager;
import com.cursedcauldron.wildbackport.common.blocks.SculkSpreadable;
import com.cursedcauldron.wildbackport.common.registry.WBBlocks;
import com.cursedcauldron.wildbackport.common.utils.DirectionUtils;
import com.mojang.serialization.Codec;

//<>

public class SculkPatchFeature extends class_3031<SculkPatchConfiguration> {
    public SculkPatchFeature(Codec<SculkPatchConfiguration> codec) {
        super(codec);
    }

    @Override
    public boolean method_13151(class_5821<SculkPatchConfiguration> context) {
        class_5281 level = context.level();
        class_2338 pos = context.origin();
        if (!this.canSpreadFrom(level, pos)) {
            return false;
        } else {
            SculkPatchConfiguration config = context.config();
            Random random = context.random();
            SculkSpreadManager spreader = SculkSpreadManager.createWorldGen();
            int rounds = config.spreadRounds() + config.growthRounds();

            for (int i = 0; i < rounds; i++) {
                for (int count = 0; count < config.chargeCount(); count++) {
                    spreader.spread(pos, config.amountPerCharge());
                }

                boolean spreadable = i < config.spreadRounds();

                for (int attempts = 0; attempts < config.spreadAttempts(); attempts++) {
                    spreader.tick(level, pos, random, spreadable);
                }

                spreader.clearCursors();
            }

            class_2338 catalystPos = pos.method_10074();
            if (random.nextFloat() <= config.catalystChance()
                && level.method_8320(catalystPos)
                       .method_26234(level, catalystPos)) {
                level.method_8652(pos, WBBlocks.SCULK_CATALYST.get().method_9564(), 3);
            }

            int extraRareGrowths = config.extraRareGrowths().sample(random);

            for (int i = 0; i < extraRareGrowths; i++) {
                class_2338 shriekPos
                    = pos.method_10069(random.nextInt(5) - 2, 0, random.nextInt(5) - 2);
                if (level.method_8320(shriekPos).method_26215()
                    && level.method_8320(shriekPos.method_10074())
                           .method_26206(level, shriekPos.method_10074(), class_2350.field_11036)) {
                    level.method_8652(
                        shriekPos,
                        WBBlocks.SCULK_SHRIEKER.get().method_9564().method_11657(
                            SculkShriekerBlock.CAN_SUMMON, true
                        ),
                        3
                    );
                }
            }

            return true;
        }
    }

    private boolean canSpreadFrom(class_1936 level, class_2338 pos) {
        class_2680 state = level.method_8320(pos);
        if (state.method_26204() instanceof SculkSpreadable) {
            return true;
        } else {
            return (state.method_26215()
                    || (state.method_27852(class_2246.field_10382) && state.method_26227().method_15771()))
                && DirectionUtils.stream().map(pos::method_10093).anyMatch(position -> {
                       return level.method_8320(position).method_26234(
                           level, position
                       );
                   });
        }
    }
}