package com.cursedcauldron.wildbackport.common.worldgen.structure.processors;

import java.util.Optional;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2378;
import net.minecraft.class_3491;
import net.minecraft.class_3492;
import net.minecraft.class_3499;
import net.minecraft.class_3828;
import net.minecraft.class_4538;
import net.minecraft.class_6862;
import net.minecraft.class_6885;
import net.minecraft.class_6895;
import org.jetbrains.annotations.Nullable;

import com.cursedcauldron.wildbackport.common.registry.worldgen.WBStructures;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;

public class BlockTagRotProcessor extends class_3491 {
    public static final Codec<BlockTagRotProcessor> CODEC
        = RecordCodecBuilder.create(instance -> {
              return instance
                  .group(
                      class_6895.method_40340(class_2378.field_25105)
                          .optionalFieldOf("rottable_blocks")
                          .forGetter(processor -> { return processor.rottableBlocks; }),
                      Codec.floatRange(0.0F, 1.0F)
                          .fieldOf("integrity")
                          .forGetter(processor -> { return processor.integrity; })
                  )
                  .apply(instance, BlockTagRotProcessor::new);
          });

    private final Optional<class_6885<class_2248>> rottableBlocks;
    private final float integrity;

    public BlockTagRotProcessor(class_6862<class_2248> rottableBlocks, float integrity) {
        this(Optional.of(class_2378.field_11146.method_40260(rottableBlocks)), integrity);
    }

    public BlockTagRotProcessor(
        Optional<class_6885<class_2248>> rottableBlocks, float integrity
    ) {
        this.rottableBlocks = rottableBlocks;
        this.integrity = integrity;
    }

    @Override
    @Nullable
    public class_3499.class_3501 method_15110(
        class_4538 level,
        class_2338 from,
        class_2338 to,
        class_3499.class_3501 pre,
        class_3499.class_3501 post,
        class_3492 settings
    ) {
        return (this.rottableBlocks.isEmpty() || pre.field_15596.method_40143(this.rottableBlocks.get()))
                && !(settings.method_15115(post.field_15597).nextFloat() <= this.integrity)
            ? null
            : post;
    }

    @Override
    protected class_3828<?> method_16772() {
        return WBStructures.BLOCK_TAG_ROT.comp_349();
    }
}
