package com.cursedcauldron.wildbackport.core.api;

import java.util.function.Supplier;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import dev.architectury.injectables.annotations.ExpectPlatform;

/**
 * @author LordMZTE & tilera
 */
public abstract class CoreRegistry<T> {
    public final class_2378<T> registry;
    public final String modId;
    public boolean isPresent;

    protected CoreRegistry(class_2378<T> registry, String modId) {
        this.registry = registry;
        this.modId = modId;
        this.isPresent = false;
    }

    @ExpectPlatform
    public static <T> CoreRegistry<T> create(class_2378<T> key, String modId) {
        throw new AssertionError();
    }

    public abstract <E extends T> Supplier<E> register(String key, Supplier<E> entry);

    public void register() {
        if (this.isPresent)
            throw new IllegalArgumentException(
                "Duplication of Registry: " + this.registry
            );
        this.isPresent = true;
        this.bootstrap();
    }

    protected abstract void bootstrap();

    public static class DefaultRegistry<T> extends CoreRegistry<T> {
        public DefaultRegistry(class_2378<T> registry, String modId) {
            super(registry, modId);
        }

        @Override
        public <E extends T> Supplier<E> register(String key, Supplier<E> entry) {
            E registry = class_2378.method_10230(
                this.registry, new class_2960(this.modId, key), entry.get()
            );
            return () -> registry;
        }

        @Override
        public void bootstrap() {}
    }
}
