package com.cursedcauldron.wildbackport.core.api.worldgen;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.function.Consumer;
import net.minecraft.class_1959;
import net.minecraft.class_5321;
import dev.architectury.injectables.annotations.ExpectPlatform;

public class BiomeModifier {
    private static final Map<Consumer<BiomeWriter>, class_5321<class_1959>[]>
        FEATURES_PER_BIOME = new ConcurrentHashMap<>();
    private static final Map<Consumer<BiomeWriter>, class_1959.class_1961[]>
        FEATURES_PER_CATEGORY = new ConcurrentHashMap<>();
    public static final BiomeModifier INSTANCE = new BiomeModifier();

    @ExpectPlatform
    public static void setup() {
        throw new AssertionError();
    }

    public void register(BiomeWriter writer) {
        FEATURES_PER_BIOME.forEach(writer::add);
        FEATURES_PER_CATEGORY.forEach(writer::add);
    }

    @SafeVarargs
    public static void add(Consumer<BiomeWriter> writer, class_5321<class_1959>... biomes) {
        FEATURES_PER_BIOME.put(writer, biomes);
    }

    public static void add(Consumer<BiomeWriter> writer, class_1959.class_1961... biomes) {
        FEATURES_PER_CATEGORY.put(writer, biomes);
    }
}