package com.cursedcauldron.wildbackport.core.mixin.client;

import com.cursedcauldron.wildbackport.common.effects.EffectFactor;
import com.cursedcauldron.wildbackport.common.registry.WBMobEffects;
import com.cursedcauldron.wildbackport.core.api.Environment;
import net.minecraft.class_1011;
import net.minecraft.class_1043;
import net.minecraft.class_1160;
import net.minecraft.class_1293;
import net.minecraft.class_1294;
import net.minecraft.class_1309;
import net.minecraft.class_1937;
import net.minecraft.class_310;
import net.minecraft.class_3532;
import net.minecraft.class_638;
import net.minecraft.class_746;
import net.minecraft.class_757;
import net.minecraft.class_765;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_765.class)
public abstract class LightTextureMixin {
    @Shadow
    @Final
    private class_310 minecraft;
    @Shadow
    private boolean updateLightTexture;
    @Shadow
    private float blockLightRedFlicker;
    @Shadow
    protected abstract float getBrightness(class_1937 level, int i);
    @Shadow
    @Final
    private class_1043 lightTexture;
    @Shadow
    @Final
    private class_1011 lightPixels;
    @Shadow
    @Final
    private class_757 renderer;

    private class_746 getPlayer() {
        return this.minecraft.field_1724;
    }

    private float getDarknessFactor(float delta) {
        class_1293 instance
            = this.getPlayer().method_6112(WBMobEffects.DARKNESS.get());
        if (this.getPlayer().method_6059(WBMobEffects.DARKNESS.get()) && instance != null
            && EffectFactor.Instance.of(instance).getFactorCalculationData().isPresent(
            )) {
            return EffectFactor.Instance.of(instance)
                .getFactorCalculationData()
                .get()
                .lerp(this.getPlayer(), delta);
        } else {
            return 0.0F;
        }
    }

    private float getDarkness(class_1309 entity, float factor, float delta) {
        return Math.max(
            0.0F,
            class_3532.method_15362(((float) entity.field_6012 - delta) * (float) Math.PI * 0.025F) * 0.45F
                * factor
        );
    }

    //TODO simplify
    @Inject(method = "updateLightTexture(F)V", at = @At("HEAD"))
    private void updateLight(float delta, CallbackInfo ci) {
        if (Environment.isModLoaded("lod"))
            return;
        if (this.updateLightTexture) {
            this.updateLightTexture = false;
            this.minecraft.method_16011().method_15396("lightTex");
            class_638 level = this.minecraft.field_1687;
            if (level != null) {
                float skyDarken = level.method_23783(1.0F);
                float skyFlashTime
                    = level.method_23789() > 0 ? 1.0F : skyDarken * 0.95F + 0.05F;
                float darknessFactor = this.getDarknessFactor(delta);
                float darkness
                    = this.getDarkness(this.getPlayer(), darknessFactor, delta);
                float waterVision = this.getPlayer().method_3140();
                float visionScale = this.getPlayer().method_6059(class_1294.field_5925)
                    ? class_757.method_3174(this.getPlayer(), delta)
                    : (waterVision > 0.0F
                               && this.getPlayer().method_6059(class_1294.field_5927)
                           ? waterVision
                           : 0.0F);
                class_1160 vec3f = new class_1160(skyDarken, skyDarken, 1.0F);
                vec3f.method_23847(new class_1160(1.0F, 1.0F, 1.0F), 0.35F);
                float blockLightFlicker = this.blockLightRedFlicker + 1.5F;
                class_1160 vec3f2 = new class_1160();

                for (int skyLight = 0; skyLight < 16; ++skyLight) {
                    for (int blockLight = 0; blockLight < 16; ++blockLight) {
                        float skyBrightness
                            = this.getBrightness(level, skyLight) * skyFlashTime;
                        float blockBrightness
                            = this.getBrightness(level, blockLight) * blockLightFlicker;
                        float yLight = blockBrightness
                            * ((blockBrightness * 0.6F + 0.4F) * 0.6F + 0.4F);
                        float xzLight = blockBrightness
                            * (blockBrightness * blockBrightness * 0.6F + 0.4F);
                        vec3f2.method_4949(blockBrightness, yLight, xzLight);
                        boolean forceLightmap = level.method_28103().method_28114();

                        if (forceLightmap) {
                            vec3f2.method_23847(new class_1160(0.99F, 1.12F, 1.0F), 0.25F);
                            vec3f2.method_4946(0.0F, 1.0F);
                        } else {
                            class_1160 vec3f3 = vec3f.method_23850();
                            vec3f3.method_4942(skyBrightness);
                            vec3f2.method_23846(vec3f3);
                            vec3f2.method_23847(new class_1160(0.75F, 0.75F, 0.75F), 0.04F);
                            if (this.renderer.method_3195(delta) > 0.0f) {
                                float darkenWorldAmount
                                    = this.renderer.method_3195(delta);
                                class_1160 vec3f4 = vec3f2.method_23850();
                                vec3f4.method_23849(0.7F, 0.6F, 0.6F);
                                vec3f2.method_23847(vec3f4, darkenWorldAmount);
                            }
                        }

                        if (visionScale > 0.0F) {
                            float modifier
                                = Math.max(vec3f2.method_4943(), Math.max(vec3f2.method_4945(), vec3f2.method_4947()));
                            if (modifier < 1.0F) {
                                float scale = 1.0F / modifier;
                                class_1160 vec3f3 = vec3f2.method_23850();
                                vec3f3.method_4942(scale);
                                vec3f2.method_23847(vec3f3, visionScale);
                            }
                        }

                        if (!forceLightmap) {
                            if (darkness > 0.0F) {
                                vec3f2.method_4948(-darkness, -darkness, -darkness);
                            }

                            vec3f2.method_4946(0.0F, 1.0F);
                        }

                        float gamma = (float) this.minecraft.field_1690.field_1840;
                        class_1160 vec3f3 = vec3f2.method_23850();
                        vec3f3.method_23848(this::notGamma);
                        vec3f2.method_23847(vec3f3, Math.max(0.0F, gamma - darknessFactor));
                        vec3f2.method_23847(new class_1160(0.75F, 0.75F, 0.75F), 0.04F);
                        vec3f2.method_4946(0.0F, 1.0F);
                        vec3f2.method_4942(255.0F);
                        int x = (int) vec3f2.method_4943();
                        int y = (int) vec3f2.method_4945();
                        int z = (int) vec3f2.method_4947();
                        this.lightPixels.method_4305(
                            blockLight, skyLight, -16777216 | z << 16 | y << 8 | x
                        );
                    }
                }

                this.lightTexture.method_4524();
                this.minecraft.method_16011().method_15407();
            }
        }
    }

    private float notGamma(float f) {
        float g = 1.0f - f;
        return 1.0f - g * g * g * g;
    }
}