package com.cursedcauldron.wildbackport.core.mixin.client;

import java.util.List;
import java.util.Map;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_5603;
import net.minecraft.class_630;
import com.cursedcauldron.wildbackport.client.animation.api.Animated;
import com.cursedcauldron.wildbackport.client.render.model.Drawable;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

//<>

@Mixin(class_630.class)
public abstract class ModelPartMixin implements Animated, Drawable {
    @Shadow
    public boolean visible;
    @Shadow
    @Final
    private List<class_630.class_628> cubes;
    @Shadow
    @Final
    private Map<String, class_630> children;
    @Shadow
    public abstract void translateAndRotate(class_4587 pose);

    private float scaleX = 1.0F;
    private float scaleY = 1.0F;
    private float scaleZ = 1.0F;
    private class_5603 defaultPose = class_5603.field_27701;
    private boolean skipDraw;

    @Override
    public class_5603 resetToDefault() {
        return this.defaultPose;
    }

    @Override
    public void setDefault(class_5603 pose) {
        this.defaultPose = pose;
    }

    @Inject(method = "loadPose", at = @At("TAIL"))
    private void wb$load(class_5603 pose, CallbackInfo ci) {
        this.scaleX = 1.0F;
        this.scaleY = 1.0F;
        this.scaleZ = 1.0F;
    }

    @Inject(method = "copyFrom", at = @At("TAIL"))
    private void wb$copy(class_630 part, CallbackInfo ci) {
        this.scaleX(Animated.of(part).scaleX());
        this.scaleY(Animated.of(part).scaleY());
        this.scaleZ(Animated.of(part).scaleZ());
    }

    @Inject(method = "translateAndRotate", at = @At("TAIL"))
    private void wb$moveAndScale(class_4587 stack, CallbackInfo ci) {
        if (this.scaleX != 1.0F || this.scaleY != 1.0F || this.scaleZ != 1.0F) {
            stack.method_22905(this.scaleX, this.scaleY, this.scaleZ);
        }
    }

    @Inject(
        method
        = "render(Lcom/mojang/blaze3d/vertex/PoseStack;Lcom/mojang/blaze3d/vertex/VertexConsumer;IIFFFF)V",
        at = @At("HEAD"),
        cancellable = true
    )
    private void
    wb$render(
        class_4587 pose,
        class_4588 consumer,
        int light,
        int delta,
        float red,
        float green,
        float blue,
        float alpha,
        CallbackInfo ci
    ) {
        if (this.skipDraw()) {
            if (this.visible) {
                if (!this.cubes.isEmpty() || !this.children.isEmpty()) {
                    pose.method_22903();
                    this.translateAndRotate(pose);

                    for (class_630 part : this.children.values())
                        part.method_22699(
                            pose, consumer, light, delta, red, green, blue, alpha
                        );
                    pose.method_22909();
                }
            }

            ci.cancel();
        }
    }

    @Override
    public float scaleX() {
        return this.scaleX;
    }

    @Override
    public void scaleX(float x) {
        this.scaleX = x;
    }

    @Override
    public void scaleXTo(float x) {
        this.scaleX += x;
    }

    @Override
    public float scaleY() {
        return this.scaleY;
    }

    @Override
    public void scaleY(float y) {
        this.scaleY = y;
    }

    @Override
    public void scaleYTo(float y) {
        this.scaleY += y;
    }

    @Override
    public float scaleZ() {
        return this.scaleZ;
    }

    @Override
    public void scaleZ(float z) {
        this.scaleZ = z;
    }

    @Override
    public void scaleZTo(float z) {
        this.scaleZ += z;
    }

    @Override
    public boolean skipDraw() {
        return this.skipDraw;
    }

    @Override
    public void setSkipDraw(boolean skipDraw) {
        this.skipDraw = skipDraw;
    }
}