package com.cursedcauldron.wildbackport.core.mixin.common;

import com.cursedcauldron.wildbackport.common.entities.access.EntityExperience;
import com.cursedcauldron.wildbackport.common.registry.WBGameEvents;
import net.minecraft.class_1282;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1937;
import org.jetbrains.annotations.Nullable;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_1309.class)
public abstract class LivingEntityMixin extends class_1297 implements EntityExperience {
    @Shadow
    @Nullable
    protected class_1657 lastHurtByPlayer;
    private boolean expDroppingDisabled;

    public LivingEntityMixin(class_1299<?> type, class_1937 level) {
        super(type, level);
    }

    @Shadow
    protected abstract int getExperienceReward(class_1657 player);

    @Inject(method = "die", at = @At("HEAD"))
    private void wb$die(class_1282 source, CallbackInfo ci) {
        this.method_32876(WBGameEvents.ENTITY_DIE.get());
    }

    @Override
    public void disableExpDrop() {
        this.expDroppingDisabled = true;
    }

    @Override
    public boolean isExpDropDisabled() {
        return this.expDroppingDisabled;
    }

    @Override
    public int getExpToDrop() {
        return this.getExperienceReward(this.lastHurtByPlayer);
    }

    @Inject(method = "dropExperience", at = @At("HEAD"), cancellable = true)
    private void wb$dropExp(CallbackInfo ci) {
        if (this.isExpDropDisabled())
            ci.cancel();
    }
}