package com.cursedcauldron.wildbackport.core.mixin.common;

import java.util.Optional;
import java.util.function.Supplier;
import net.minecraft.class_1291;
import net.minecraft.class_1293;
import net.minecraft.class_1309;
import net.minecraft.class_2487;
import net.minecraft.class_2509;
import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.common.effects.EffectFactor;
import com.cursedcauldron.wildbackport.common.effects.FactorCalculationData;
import com.mojang.serialization.Dynamic;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_1291.class)
public class MobEffectMixin implements EffectFactor {
    private Supplier<FactorCalculationData> factorCalculationData = () -> null;

    @Override
    public class_1291 setFactorCalculationData(Supplier<FactorCalculationData> data) {
        this.factorCalculationData = data;
        return class_1291.class.cast(this);
    }

    @Override
    public Supplier<FactorCalculationData> getFactorCalculationData() {
        return this.factorCalculationData;
    }

    @Mixin(class_1293.class)
    public static class MobEffectInstanceMixin implements EffectFactor.Instance {
        @Shadow
        @Final
        private class_1291 effect;
        @Shadow
        private int duration;
        private Optional<FactorCalculationData> factorCalculationData;

        @Inject(
            method
            = "<init>(Lnet/minecraft/world/effect/MobEffect;IIZZZLnet/minecraft/world/effect/MobEffectInstance;)V",
            at = @At("TAIL")
        )
        private void
        wb$create(
            class_1291 effect,
            int duration,
            int amplifier,
            boolean ambient,
            boolean showParticles,
            boolean showIcon,
            class_1293 hiddenEffect,
            CallbackInfo ci
        ) {
            this.setFactorCalculationData(EffectFactor.create(effect));
        }

        @Inject(
            method = "<init>(Lnet/minecraft/world/effect/MobEffectInstance;)V",
            at = @At("TAIL")
        )
        private void
        wb$create(class_1293 instance, CallbackInfo ci) {
            this.setFactorCalculationData(EffectFactor.create(this.effect));
        }

        @Override
        public void setFactorCalculationData(Optional<FactorCalculationData> data) {
            this.factorCalculationData = data;
        }

        @Override
        public Optional<FactorCalculationData> getFactorCalculationData() {
            return this.factorCalculationData;
        }

        @Inject(method = "update", at = @At("HEAD"), cancellable = true)
        private void
        wb$update(class_1293 instance, CallbackInfoReturnable<Boolean> cir) {
            int i = this.duration;
            if (i != this.duration) {
                this.factorCalculationData.ifPresent(
                    data -> data.effectChangedTimestamp += this.duration - i
                );
                cir.setReturnValue(true);
            }
        }

        @Inject(method = "tick", at = @At("HEAD"))
        private void wb$tick(
            class_1309 entity, Runnable runnable, CallbackInfoReturnable<Boolean> cir
        ) {
            this.factorCalculationData.ifPresent(
                data -> data.update(class_1293.class.cast(this))
            );
        }

        @Inject(method = "writeDetailsTo", at = @At("TAIL"))
        private void wb$write(class_2487 tag, CallbackInfo ci) {
            this.factorCalculationData
                .flatMap(
                    instance
                    -> FactorCalculationData.CODEC.encodeStart(class_2509.field_11560, instance)
                           .resultOrPartial(WildBackport.LOGGER::error)
                )
                .ifPresent(data -> tag.method_10566("FactorCalculationData", data));
        }

        @Inject(method = "loadSpecifiedEffect", at = @At("TAIL"))
        private static void wb$load(
            class_1291 effect,
            class_2487 tag,
            CallbackInfoReturnable<class_1293> cir
        ) {
            Optional<FactorCalculationData> data
                = tag.method_10573("FactorCalculationData", 10)
                ? FactorCalculationData.CODEC
                      .parse(new Dynamic<>(
                          class_2509.field_11560, tag.method_10562("FactorCalculationData")
                      ))
                      .resultOrPartial(WildBackport.LOGGER::error)
                : Optional.empty();
            EffectFactor.Instance.of(cir.getReturnValue()).setFactorCalculationData(data);
        }
    }
}