package com.cursedcauldron.wildbackport.core.mixin.common;

import java.util.Optional;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2509;
import net.minecraft.class_2940;
import net.minecraft.class_2945;
import net.minecraft.class_4208;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.cursedcauldron.wildbackport.common.entities.access.Recovery;
import com.cursedcauldron.wildbackport.common.entities.access.WardenTracker;
import com.cursedcauldron.wildbackport.common.entities.warden.WardenSpawnTracker;
import com.cursedcauldron.wildbackport.common.utils.GlobalPosEntityDataSerializer;
import com.mojang.authlib.GameProfile;
import com.mojang.serialization.Dynamic;

//<>

@Mixin(class_1657.class)
public abstract class PlayerMixin
    extends class_1309 implements WardenTracker, Recovery {
    private static final class_2940<Optional<class_4208>>
        DATA_LAST_DEATH_LOCATION_ID = class_2945.method_12791(
            class_1657.class, GlobalPosEntityDataSerializer.OPTIONAL_INSTANCE
        );

    protected PlayerMixin(class_1299<? extends class_1309> entityType, class_1937 level) {
        super(entityType, level);
        throw new AssertionError();
    }

    @Unique
    private WardenSpawnTracker spawnTracker;

    @Unique
    private Optional<class_4208> lastDeathLocation = Optional.empty();

    @Inject(method = "<init>", at = @At("TAIL"))
    private void wb$init(
        class_1937 alec1, class_2338 alec2, float alec3, GameProfile alec4, CallbackInfo ci
    ) {
        this.spawnTracker = new WardenSpawnTracker(0, 0, 0);
    }

    @Inject(method = "tick", at = @At("TAIL"))
    private void wb$tick(CallbackInfo ci) {
        if (!((class_1657) (Object) this).field_6002.field_9236)
            this.spawnTracker.tick();
    }

    @Inject(method = "readAdditionalSaveData", at = @At("TAIL"))
    private void wb$readData(class_2487 tag, CallbackInfo ci) {
        if (tag.method_10573("warden_spawn_tracker", 10))
            WardenSpawnTracker.CODEC
                .parse(new Dynamic<>(class_2509.field_11560, tag.method_10580("warden_spawn_tracker")))
                .resultOrPartial(WildBackport.LOGGER::error)
                .ifPresent(tracker -> this.spawnTracker = tracker);

        if (tag.method_10573("last_death_location", 10))
            class_4208.field_25066
                .parse(new Dynamic<>(class_2509.field_11560, tag.method_10580("last_death_location")))
                .resultOrPartial(WildBackport.LOGGER::error)
                .ifPresent(pos -> this.setLastDeathLocation(Optional.of(pos)));
    }

    @Inject(method = "addAdditionalSaveData", at = @At("TAIL"))
    private void wb$writeData(class_2487 tag, CallbackInfo ci) {
        WardenSpawnTracker.CODEC.encodeStart(class_2509.field_11560, this.spawnTracker)
            .resultOrPartial(WildBackport.LOGGER::error)
            .ifPresent(tracker -> tag.method_10566("warden_spawn_Tracker", tracker));

        this.getLastDeathLocation().ifPresent(
            pos
            -> class_4208.field_25066.encodeStart(class_2509.field_11560, pos)
                   .resultOrPartial(WildBackport.LOGGER::error)
                   .ifPresent(serialized -> tag.method_10566("last_death_location", serialized))
        );
    }

    @Inject(method = "defineSynchedData", at = @At("TAIL"))
    private void wb$defineSynchedData(CallbackInfo ci) {
        this.field_6011.method_12784(DATA_LAST_DEATH_LOCATION_ID, Optional.empty());
    }

    @Inject(method = "blockUsingShield", at = @At("HEAD"))
    private void wb$blockShield(class_1309 entity, CallbackInfo ci) {
        if (entity instanceof Warden)
            ((class_1657) (Object) this).method_7284(true);
    }

    @Override
    public WardenSpawnTracker getWardenSpawnTracker() {
        return this.spawnTracker;
    }

    @Override
    public Optional<class_4208> getLastDeathLocation() {
        return this.field_6011.method_12789(DATA_LAST_DEATH_LOCATION_ID);
    }

    @Override
    public void setLastDeathLocation(Optional<class_4208> location) {
        this.field_6011.method_12778(DATA_LAST_DEATH_LOCATION_ID, location);
    }
}
