package com.cursedcauldron.wildbackport.core.mixin.common;

import com.cursedcauldron.wildbackport.common.entities.access.Vibration;
import net.minecraft.class_1297;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_3218;
import net.minecraft.class_5712;
import net.minecraft.class_5718;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_5718.class)
public class VibrationListenerMixin implements Vibration.Instance {
    private class_2338 pos;
    private class_1297 entity;
    private class_1297 source;
    private Vibration vibration;

    @Inject(method = "handleGameEvent", at = @At("HEAD"))
    private void handleSource(
        class_1937 level,
        class_5712 event,
        class_1297 entity,
        class_2338 pos,
        CallbackInfoReturnable<Boolean> cir
    ) {
        if (level instanceof class_3218 server) {
            this.setPos(pos);
            this.setVibration(new Vibration(entity));
            this.setEntity(this.vibration.getEntity(server).orElse(null));
            this.setSource(this.vibration.getOwner(server).orElse(null));
        }
    }

    @Override
    public void setPos(class_2338 pos) {
        this.pos = pos;
    }

    @Override
    public class_2338 getPos() {
        return this.pos;
    }

    @Override
    public void setEntity(class_1297 entity) {
        this.entity = entity;
    }

    @Override
    public class_1297 getEntity() {
        return this.entity;
    }

    @Override
    public void setSource(class_1297 entity) {
        this.source = entity;
    }

    @Override
    public class_1297 getSource() {
        return this.source;
    }

    @Override
    public void setVibration(Vibration vibration) {
        this.vibration = vibration;
    }
}