package com.cursedcauldron.wildbackport.core.mixin.network;

import java.util.function.BiConsumer;
import java.util.function.Function;
import net.minecraft.class_1293;
import net.minecraft.class_2540;
import net.minecraft.class_2783;
import com.cursedcauldron.wildbackport.common.effects.EffectFactor;
import com.cursedcauldron.wildbackport.common.effects.FactorCalculationData;
import org.jetbrains.annotations.Nullable;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_2783.class)
public class ClientboundUpdateMobEffectPacketMixin implements EffectFactor.Network {
    private FactorCalculationData factorCalculationData;

    @Inject(
        method = "<init>(ILnet/minecraft/world/effect/MobEffectInstance;)V",
        at = @At("TAIL")
    )
    private void
    create(int id, class_1293 instance, CallbackInfo ci) {
        this.factorCalculationData
            = EffectFactor.Instance.of(instance).getFactorCalculationData().orElse(null);
    }

    @Inject(method = "<init>(Lnet/minecraft/network/FriendlyByteBuf;)V", at = @At("TAIL"))
    private void create(class_2540 buf, CallbackInfo ci) {
        this.factorCalculationData = this.readNullable(
            buf, buffer -> buffer.method_29171(FactorCalculationData.CODEC)
        );
    }

    @Inject(method = "write", at = @At("TAIL"))
    private void writeData(class_2540 buf, CallbackInfo ci) {
        this.writeNullable(
            buf,
            this.factorCalculationData,
            (buffer, data) -> buffer.method_29172(FactorCalculationData.CODEC, data)
        );
    }

    @Override
    public FactorCalculationData getFactorCalculationData() {
        return this.factorCalculationData;
    }

    private <T>
        T readNullable(class_2540 buf, Function<class_2540, T> consumer) {
        return buf.readBoolean() ? consumer.apply(buf) : null;
    }

    private <T> void writeNullable(
        class_2540 buf, @Nullable T entry, BiConsumer<class_2540, T> consumer
    ) {
        if (entry != null) {
            buf.writeBoolean(true);
            consumer.accept(buf, entry);
        } else {
            buf.writeBoolean(false);
        }
    }
}